
if SERVER then
	AddCSLuaFile("shared.lua")
end

if CLIENT then

	SWEP.PrintName		= "SWEP Construction Kit"
	SWEP.Author			= "Clavus"
	SWEP.Contact		= "clavus@clavusstudios.com"
	SWEP.Purpose		= "Design SWEP ironsights and clientside models"
	SWEP.Instructions	= "http://tinyurl.com/swepkit"
	SWEP.Slot			= 5
	SWEP.SlotPos		= 10
	SWEP.ViewModelFlip	= false

	SWEP.ShowViewModel 	= true
	SWEP.ShowWorldModel = true
	
end

SWEP.HoldType = "pistol"
SWEP.HoldTypes = { "normal", "melee", "melee2", "fist", 
"knife", "smg", "ar2", "pistol", "rpg", "physgun", 
"grenade", "shotgun", "crossbow", "slam" }

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_pistol.mdl"
SWEP.WorldModel			= "models/weapons/w_pistol.mdl"
SWEP.CurWorldModel 		= "models/weapons/w_pistol.mdl" // this is where shit gets hacky 

SWEP.ViewModelFOV		= 70
SWEP.BobScale			= 0
SWEP.SwayScale			= 0

SWEP.Primary.Automatic	= false

SWEP.IronsightTime = 0.2

SWEP.IronSightsPos = Vector(0, 0, 0)
SWEP.IronSightsAng = Vector(0, 0, 0)

function SWEP:Initialize()
	
	self:SetWeaponHoldType(self.HoldType)
	
	self:SetIronSights( true )
	self:ResetIronSights()
	
	if CLIENT then
		self:CreateWeaponWorldModel()
		self:ClientInit()
		if (not file.IsDir("swep_construction_kit")) then
			file.CreateDir("swep_construction_kit")
		end
	end
	
end

function SWEP:PrimaryAttack()

	self.Weapon:SetNextPrimaryFire(CurTime() + 0.2)

	if CLIENT then
		self:OpenMenu()
	end
	if SinglePlayer() then
		self.Owner:SendLua("LocalPlayer():GetActiveWeapon():OpenMenu()")
	end
	
end

function SWEP:SecondaryAttack()
	
	self.Weapon:SetNextSecondaryFire(CurTime() + 0.2)
	
	if CLIENT then
		self:OpenMenu()
	end
	if SinglePlayer() then
		self.Owner:SendLua("LocalPlayer():GetActiveWeapon():OpenMenu()")
	end
	
end


function SWEP:SetupDataTables()

	self:DTVar( "Bool", 0, "ironsights" )
	self:DTVar( "Bool", 1, "thirdperson" )
	
end

function SWEP:ToggleIronSights()
	self.dt.ironsights = !self.dt.ironsights
end

function SWEP:SetIronSights( b )
	self.dt.ironsights = b
end

function SWEP:GetIronSights()
	return self.dt.ironsights
end

function SWEP:ResetIronSights()
	RunConsoleCommand("_sp_ironsight_x", 0)
	RunConsoleCommand("_sp_ironsight_y", 0)
	RunConsoleCommand("_sp_ironsight_z", 0)
	RunConsoleCommand("_sp_ironsight_pitch", 0)
	RunConsoleCommand("_sp_ironsight_yaw", 0)
	RunConsoleCommand("_sp_ironsight_roll", 0)
end

function SWEP:ToggleThirdPerson()
	self.dt.thirdperson = !self.dt.thirdperson
	if (self.dt.thirdperson) then self.Owner:CrosshairDisable()
	else self.Owner:CrosshairEnable() end
end

function SWEP:SetThirdPerson( b )
	self.dt.thirdperson = b
	if (self.dt.thirdperson) then self.Owner:CrosshairDisable()
	else self.Owner:CrosshairEnable() end
end

function SWEP:GetThirdPerson()
	return self.dt.thirdperson
end

function SWEP:GetViewModelPosition(pos, ang)

	local bIron = self.dt.ironsights
	local fIronTime = self.fIronTime or 0

	if (not bIron and fIronTime < CurTime() - self.IronsightTime) then
		return pos, ang
	end
	
	self.IronSightsPos, self.IronSightsAng = self:GetIronSightCoordination()

	local Mul = 1.0

	if (fIronTime > CurTime() - self.IronsightTime) then
		Mul = math.Clamp((CurTime() - fIronTime) / self.IronsightTime, 0, 1)

		if not bIron then Mul = 1 - Mul end
	end

	local Offset	= self.IronSightsPos

	if (self.IronSightsAng) then
		ang = ang * 1
		ang:RotateAroundAxis(ang:Right(), 		self.IronSightsAng.x * Mul)
		ang:RotateAroundAxis(ang:Up(), 		self.IronSightsAng.y * Mul)
		ang:RotateAroundAxis(ang:Forward(), 	self.IronSightsAng.z * Mul)
	end

	local Right 	= ang:Right()
	local Up 		= ang:Up()
	local Forward 	= ang:Forward()

	pos = pos + Offset.x * Right * Mul
	pos = pos + Offset.y * Forward * Mul
	pos = pos + Offset.z * Up * Mul
	
	return pos, ang
end

local ir_x = CreateConVar( "_sp_ironsight_x", 0.0 )
local ir_y = CreateConVar( "_sp_ironsight_y", 0.0 )
local ir_z = CreateConVar( "_sp_ironsight_z", 0.0 )
local ir_p = CreateConVar( "_sp_ironsight_pitch", 0.0 )
local ir_yw = CreateConVar( "_sp_ironsight_yaw", 0.0 )
local ir_r = CreateConVar( "_sp_ironsight_roll", 0.0 )

function SWEP:GetIronSightCoordination()
	
	local vec = Vector( ir_x:GetFloat(), ir_y:GetFloat(), ir_z:GetFloat() )
	local ang = Vector( ir_p:GetFloat(), ir_yw:GetFloat(), ir_r:GetFloat() )
	return vec, ang
	
end

function SWEP:GetHoldTypes()
	return self.HoldTypes
end

SWEP.LastOwner = nil
/***************************
	Helper functions
***************************/
SWEP.IsSCK = true
local function GetSWEP( pl )
	local wep = pl:GetActiveWeapon()
	if (ValidEntity(wep) and wep.IsSCK) then
		return wep
	end
	//Error("Not holding SWEP Construction Kit!")
	return NULL
end
	
/***********************************************
		SERVER CODE YEEEEEAAAAAHHH
***********************************************/
if SERVER then
	
	function SWEP:Deploy()
		self.LastOwner = self.Owner
	end

	function SWEP:OnDrop()
		if (ValidEntity(self.LastOwner)) then
			self.LastOwner:SendLua("Entity("..self:EntIndex().."):OnDropWeapon()")
		end
		self.LastOwner = nil
	end
	
	local function Cmd_SetHoldType( pl, cmd, args )

		local holdtype = args[1]
		local wep = GetSWEP( pl )
		if (ValidEntity(wep) and holdtype and table.HasValue( wep:GetHoldTypes(), holdtype )) then
			wep:SetWeaponHoldType( holdtype )
			wep.HoldType = holdtype
		end	

	end
	concommand.Add("swepck_setholdtype", Cmd_SetHoldType)

	local function Cmd_ToggleThirdPerson( pl, cmd, args )

		local wep = GetSWEP( pl )
		if (ValidEntity(wep)) then
			wep:ToggleThirdPerson()
		end

	end
	concommand.Add("swepck_togglethirdperson", Cmd_ToggleThirdPerson)
	
	local function Cmd_PlayAnimation( pl, cmd, args )

		local wep = GetSWEP( pl )
		if (ValidEntity(wep)) then
			local anim = tonumber(args[1] or 0)
			wep:ResetSequenceInfo()
			wep:SendWeaponAnim( anim )
		end
		
	end
	concommand.Add("swepck_playanimation", Cmd_PlayAnimation)
	
	local function Cmd_ToggleSights( pl, cmd, args )

		local wep = GetSWEP( pl )
		if (ValidEntity(wep)) then
			wep:ToggleIronSights()
		end

	end
	concommand.Add("swepck_toggleironsights", Cmd_ToggleSights)

	local function Cmd_ViewModelFOV( pl, cmd, args )

		local wep = GetSWEP( pl )
		if (ValidEntity(wep)) then
			wep.ViewModelFOV = tonumber(args[1] or wep.ViewModelFOV)
		end
		
	end
	concommand.Add("swepck_viewmodelfov", Cmd_ViewModelFOV)
	
	local function Cmd_ViewModel( pl, cmd, args )

		local wep = GetSWEP( pl )
		if (!ValidEntity(wep)) then return end
		local newmod = args[1] or wep.ViewModel
		newmod = newmod..".mdl"
		if !file.Exists ("../"..newmod) then return end
		
		util.PrecacheModel(newmod)
		wep.ViewModel = newmod
		pl:GetViewModel():SetWeaponModel(newmod, wep)
		pl:SendLua([[LocalPlayer():GetActiveWeapon().ViewModel = "]]..newmod..[["]])
		//pl:SendLua([[LocalPlayer():GetViewModel():SetModel("]]..newmod..[[")]])
		pl:SendLua([[LocalPlayer():GetViewModel():SetWeaponModel("]]..newmod..[[", Entity(]]..wep:EntIndex()..[[))]])
		
		local quickswitch = nil
		for k, v in pairs( pl:GetWeapons() ) do
			if (v:GetClass() != wep:GetClass()) then 
				quickswitch = v:GetClass()
				break
			end
		end
		
		if (quickswitch) then
			pl:SelectWeapon( quickswitch )
			pl:SelectWeapon( wep:GetClass() )
		else
			pl:ChatPrint("Switch weapons to make the new viewmodel show up")
		end
		
		//print("Changed viewmodel to \""..wep.ViewModel.."\"")
		
	end
	concommand.Add("swepck_viewmodel", Cmd_ViewModel)
	
	local function Cmd_WorldModel( pl, cmd, args )

		local wep = GetSWEP( pl )
		if (!ValidEntity(wep)) then return end
		local newmod = args[1] or wep.CurWorldModel
		newmod = newmod..".mdl"
		if !file.Exists ("../"..newmod) then return end
		
		util.PrecacheModel(newmod)
		wep.CurWorldModel = newmod
		wep:SetModel(newmod)
		pl:SendLua([[LocalPlayer():GetActiveWeapon().CurWorldModel = "]]..newmod..[["]])
		pl:SendLua([[LocalPlayer():GetActiveWeapon():CreateWeaponWorldModel()]])
		//print("Changed worldmodel to \""..wep.CurWorldModel.."\"")
		
	end
	concommand.Add("swepck_worldmodel", Cmd_WorldModel)

end

/***********************************************
		CLIENT CODE WHOOOOOOOOOOO
***********************************************/
if CLIENT then
	
	surface.CreateFont("Arial", 12, 500, true, false, "12ptFont")
	surface.CreateFont("Arial", 24, 500, true, false, "24ptFont")
	
	local useThirdPerson = false
	local thirdPersonAngle = Angle(0,-90,0)
	local thirdPersonDis = 100
	local mlast_x = ScrW()/2
	local mlast_y = ScrH()/2
	
	local v_models = {}
	local v_panelCache = {}
	local v_modelListing = nil
	local v_bonescales = {}
	local v_modelbonebox = nil
	
	local w_models = {}
	local w_panelCache = {}
	local w_modelListing = nil
	
	local world_model = nil
	local cur_wmodel = nil
	
	local browser_callback = nil
	local modelbrowser = nil
	local modelbrowser_list = nil
	local matbrowser = nil
	local matbrowser_list = nil
	
	local save_data = {}
	local save_data_template = {
		ViewModel = SWEP.ViewModel,
		CurWorldModel = SWEP.CurWorldModel,
		w_models = {},
		v_models = {},
		v_bonescales = {},
		ViewModelFOV = SWEP.ViewModelFOV,
		HoldType = SWEP.HoldType,
		ViewModelFlip = SWEP.ViewModelFlip,
		IronSightsEnabled = true,
		IronSightsPos = SWEP.IronSightsPos,
		IronSightsAng = SWEP.IronSightsAng,
		ShowViewModel = true,
		ShowWorldModel = true
	}

	local ir_drag = {
		x = { true, "-x", 25 },
		y = { false, "y", 25 },
		z = { true, "y", 25 },
		pitch = { false, "y", 10 },
		yaw = { false, "x", 10 },
		roll = { false, "y", 10 }
	}
	local drag_modes = {
		["x / z"] = { "x", "z" },
		["y"] = { "y" },
		["pitch / yaw"] = { "pitch", "yaw" },
		["roll"] = { "roll" }	
	}
	local cur_drag_mode = "x / z"
	SWEP.Frame = nil
	
	local function PrintVec( vec )
		local px, py, pz = math.floor(vec.x*1000)/1000,math.floor(vec.y*1000)/1000,math.floor(vec.z*1000)/1000
		return "Vector("..px..", "..py..", "..pz..")"
	end
	
	local function PrintAngle( angle )
		local pp, py, pr = math.floor(angle.p*1000)/1000,math.floor(angle.y*1000)/1000,math.floor(angle.r*1000)/1000
		return "Angle("..pp..", "..py..", "..pr..")"
	end
	
	local function PrintColor( col )
		return "Color("..col.r..", "..col.g..", "..col.b..", "..col.a..")"
	end	

	function SWEP:ClientInit()
	
		// init view model bone build function
		self.BuildViewModelBones = function( s )
			if LocalPlayer():GetActiveWeapon() == self and v_bonescales then
				for k, v in pairs( v_bonescales ) do
					local bone = s:LookupBone(k)
					if (!bone) then continue end
					local m = s:GetBoneMatrix(bone)
					if (!m) then continue end
					m:Scale(v)
					s:SetBoneMatrix(bone, m)
				end
			end
		end
		
	end
	
	// Populates a DMultiChoice with all the bones of the viewmodel
	// returns if it has a first option
	local function PopulateBoneList( choicelist )
		if (!ValidEntity(choicelist)) then return false end
		local viewmodel = LocalPlayer():GetViewModel()
		local hasfirstoption
		for i = 0, viewmodel:GetBoneCount() - 1 do
			local name = viewmodel:GetBoneName(i)
			if (viewmodel:LookupBone(name)) then // filter out invalid bones
				choicelist:AddChoice(name)
				if (!firstoption) then hasfirstoption = true end
			end
		end
		return hasfirstoption
	end
	
	local function GetWeaponPrintText( wep )
		
		str = ""
		str = str.."SWEP.HoldType = \""..wep.HoldType.."\"\n"
		str = str.."SWEP.ViewModelFOV = "..wep.ViewModelFOV.."\n"
		str = str.."SWEP.ViewModelFlip = "..tostring(wep.ViewModelFlip).."\n"
		str = str.."SWEP.ViewModel = \""..wep.ViewModel.."\"\n"
		str = str.."SWEP.WorldModel = \""..wep.CurWorldModel.."\"\n"
		str = str.."SWEP.ShowViewModel = "..tostring(wep.ShowViewModel).."\n"
		str = str.."SWEP.ShowWorldModel = "..tostring(wep.ShowWorldModel).."\n"
		str = str.."SWEP.ViewModelBonescales = {"
		local i = 0
		for k, v in pairs( v_bonescales ) do
			if (v == Vector(1,1,1)) then continue end
			if (i == 1) then
				str = str..", "
			end
			i = 1
			str = str.."[\""..k.."\"] = "..PrintVec( v )
		end
		str = str.."}"
		
		return str
		
	end
	
	local function GetIronSightPrintText( vec, ang )
		return "SWEP.IronSightsPos = "..PrintVec( vec ).."\nSWEP.IronSightsAng = "..PrintVec( ang )
	end
	
	local function GetVModelsText()
		local str = ("SWEP.VElements = {\n")
		local i = 0
		local num = table.Count(v_models)
		for k, v in pairs( v_models ) do
		
			if (v.type == "Model") then
				str = str.."\t[\""..k.."\"] = { type = \"Model\", model = \""..v.model.."\", bone = \""..v.bone.."\", pos = "..PrintVec(v.pos)
				str = str..", angle = "..PrintAngle( v.angle )..", size = "..PrintVec(v.size)..", color = "..PrintColor( v.color )
				str = str..", surpresslightning = "..tostring(v.surpresslightning)..", material = \""..v.material.."\", skin = "..v.skin
				str = str..", bodygroup = {"
				local i = 0
				for k, v in pairs( v.bodygroup ) do
					if (v <= 0) then continue end
					if ( i != 0 ) then str = str..", " end
					i = 1
					str = str.."["..k.."] = "..v
				end
				str = str.."} }"
			elseif (v.type == "Sprite") then
				str = str.."\t[\""..k.."\"] = { type = \"Sprite\", sprite = \""..v.sprite.."\", bone = \""..v.bone.."\", pos = "..PrintVec(v.pos)
				str = str..", size = { x = "..v.size.x..", y = "..v.size.y.." }, color = "..PrintColor( v.color )..", nocull = "..tostring(v.nocull)
				str = str..", additive = "..tostring(v.additive)..", vertexalpha = "..tostring(v.vertexalpha)..", vertexcolor = "..tostring(v.vertexcolor)
				str = str..", ignorez = "..tostring(v.ignorez).."}"
			elseif (v.type == "Quad") then
				str = str.."\t[\""..k.."\"] = { type = \"Quad\", bone = \""..v.bone.."\", pos = "..PrintVec(v.pos)..", angle = "..PrintAngle( v.angle )
				str = str..", size = "..v.size..", draw_func = nil}"
			end
			
			if (v.type) then
				i = i + 1
				if (i < num) then str = str.."," end
				str = str.."\n"
			end
		end
		str = str.."}"
		return str
	end
	
	local function GetWModelsText()
		local str = ("SWEP.WElements = {\n")
		local i = 0
		local num = table.Count(w_models)
		for k, v in pairs( w_models ) do
		
			if (v.type == "Model") then
				str = str.."\t[\""..k.."\"] = { type = \"Model\", model = \""..v.model.."\", pos = "..PrintVec(v.pos)
				str = str..", angle = "..PrintAngle( v.angle )..", size = "..PrintVec(v.size)..", color = "..PrintColor( v.color )
				str = str..", surpresslightning = "..tostring(v.surpresslightning)..", material = \""..v.material.."\", skin = "..v.skin
				str = str..", bodygroup = {"
				local i = 0
				for k, v in pairs( v.bodygroup ) do
					if (v <= 0) then continue end
					if ( i != 0 ) then str = str..", " end
					i = 1
					str = str.."["..k.."] = "..v
				end
				str = str.."} }"
			elseif (v.type == "Sprite") then
				str = str.."\t[\""..k.."\"] = { type = \"Sprite\", sprite = \""..v.sprite.."\", pos = "..PrintVec(v.pos)
				str = str..", size = { x = "..v.size.x..", y = "..v.size.y.." }, color = "..PrintColor( v.color )..", nocull = "..tostring(v.nocull)
				str = str..", additive = "..tostring(v.additive)..", vertexalpha = "..tostring(v.vertexalpha)..", vertexcolor = "..tostring(v.vertexcolor)
				str = str..", ignorez = "..tostring(v.ignorez).."}"
			elseif (v.type == "Quad") then
				str = str.."\t[\""..k.."\"] = { type = \"Quad\", pos = "..PrintVec(v.pos)..", angle = "..PrintAngle( v.angle )
				str = str..", size = "..v.size..", draw_func = nil}"
			end
			
			if (v.type) then
				i = i + 1
				if (i < num) then str = str.."," end
				str = str.."\n"
			end
		end
		str = str.."}"
		return str
	end
	
	local function ClearViewModels()
		v_models = {}
		if (v_modelListing) then v_modelListing:Clear() end
		for k, v in pairs( v_panelCache ) do
			if (v) then 
				v:Remove()
			end
		end
		v_panelCache = {}
	end
	
	local function RefreshViewModelBoneScales()
		
		if (!ValidEntity(v_modelbonebox)) then return end
		v_bonescales = {}
		
		v_modelbonebox:Clear()
		
		timer.Destroy("repop")
		
		timer.Create("repop", 1, 1, function()
			local option = PopulateBoneList( v_modelbonebox )
			if (option) then
				v_modelbonebox:ChooseOptionID(1)
			end
		end)
	
	end
	
	local function ClearWorldModels()
		w_models = {}
		if (w_modelListing) then w_modelListing:Clear() end
		for k, v in pairs( w_panelCache ) do
			if (v) then 
				v:Remove()
			end
		end
		w_panelCache = {}
	end
	
	function SWEP:CreateWeaponWorldModel()
		
		local model = self.CurWorldModel
		
		if ((!world_model or (ValidEntity(world_model) and cur_wmodel != model)) and 
			string.find(model, ".mdl") and file.Exists ("../"..model) ) then
			
			if ValidEntity(world_model) then world_model:Remove() end
			world_model = ClientsideModel(model, RENDER_GROUP_VIEW_MODEL_OPAQUE)
			if (ValidEntity(world_model)) then
				world_model:SetParent(self.Owner)
				world_model:SetNoDraw(true)
				cur_wmodel = model
				if (world_model:LookupBone( "ValveBiped.Bip01_R_Hand" )) then
					world_model:AddEffects(EF_BONEMERGE)
				end
			else
				world_model = nil
				cur_wmodel = nil
			end

		end
		
	end

	function SWEP:CreateModels( tab )
	
		// Create the clientside models here because Garry says we can't do it in the render hook
		for k, v in pairs( tab ) do
			if (v.type == "Model" and v.model and v.model != "" and (!ValidEntity(v.modelEnt) or v.createdModel != v.model) and 
					string.find(v.model, ".mdl") and file.Exists ("../"..v.model) ) then
				
				v.modelEnt = ClientsideModel(v.model, RENDER_GROUP_VIEW_MODEL_OPAQUE)
				if (ValidEntity(v.modelEnt)) then
					v.modelEnt:SetPos(self:GetPos())
					v.modelEnt:SetAngles(self:GetAngles())
					v.modelEnt:SetParent(self)
					v.modelEnt:SetNoDraw(true)
					v.createdModel = v.model
				else
					v.modelEnt = nil
				end
				
			elseif (v.type == "Sprite" and v.sprite and v.sprite != "" and (!v.spriteMaterial or v.createdSprite != v.sprite) and file.Exists ("../materials/"..v.sprite..".vmt")) then
				
				local name = v.sprite.."-"
				local params = { ["$basetexture"] = v.sprite }
				// make sure we create a unique name based on the selected options
				local tocheck = { "nocull", "additive", "vertexalpha", "vertexcolor", "ignorez" }
				for i, j in pairs( tocheck ) do
					if (v[j]) then
						params["$"..j] = 1
						name = name.."1"
					else
						name = name.."0"
					end
				end

				v.createdSprite = v.sprite
				v.spriteMaterial = CreateMaterial(name,"UnlitGeneric",params)
				
			end
		end
		
	end
	
	function SWEP:Think()
		
		self:CreateModels( v_models )
		self:CreateModels( w_models )
		
		/************************
			Camera fiddling
		************************/
		useThirdPerson = self:GetThirdPerson()
		
		local mx, my = gui.MousePos()
		local diffx, diffy = (mx - mlast_x), (my - mlast_y)
		
		if (input.IsMouseDown(MOUSE_RIGHT) and !(diffx > 40 or diffy > 40) and self.Frame and self.Frame:IsVisible()) then // right mouse press without sudden jumps
		
			if (useThirdPerson) then
			
				if (input.IsKeyDown(KEY_E)) then
					thirdPersonDis = math.Clamp( thirdPersonDis + diffy, 10, 500 )
				else
					thirdPersonAngle = thirdPersonAngle + Angle( diffy/2, diffx/2, 0 )
				end
				
			else
				// ironsight adjustment
				for k, v in pairs( ir_drag ) do
					if (v[1]) then
						local temp = GetConVar( "_sp_ironsight_"..k ):GetFloat()
						if (v[2] == "x") then
							local add = -(diffx/v[3])
							if (self.ViewModelFlip) then add = add*-1 end
							RunConsoleCommand( "_sp_ironsight_"..k, temp + add )
						elseif (v[2] == "-x") then
							local add = diffx/v[3]
							if (self.ViewModelFlip) then add = add*-1 end
							RunConsoleCommand( "_sp_ironsight_"..k, temp + add )
						elseif (v[2] == "y") then
							RunConsoleCommand( "_sp_ironsight_"..k, temp - diffy/v[3] )
						end
					end
				end
			
			end
			
		end
		
		mlast_x, mlast_y = mx, my
	end
	
	function SWEP:RemoveModels()
		for k, v in pairs( v_models ) do
			if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
		end
		for k, v in pairs( w_models ) do
			if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
		end
		v_models = {}
		w_models = {}
	end

	/********************************
		All viewmodel drawing magic
	*********************************/
	local vRenderOrder = nil
	function SWEP:ViewModelDrawn()
		
		local vm = self.Owner:GetViewModel()
		if !ValidEntity(vm) then return end
		
		if vm.BuildBonePositions ~= self.BuildViewModelBones then
			vm.BuildBonePositions = self.BuildViewModelBones
		end
	
		if (!vRenderOrder) then
			
			// we build a render order because sprites need to be drawn after models
			vRenderOrder = {}

			for k, v in pairs( v_models ) do
				if (v.type == "Model") then
					table.insert(vRenderOrder, 1, k)
				elseif (v.type == "Sprite" or v.type == "Quad") then
					table.insert(vRenderOrder, k)
				end
			end
			
		end

		for k, name in ipairs( vRenderOrder ) do
		
			local v = v_models[name]
			if (!v) then vRenderOrder = nil break end
		
			local model = v.modelEnt
			local sprite = v.spriteMaterial
			
			if (!v.bone) then continue end
			local bone = vm:LookupBone(v.bone)
			if (!bone) then continue end
			
			local pos, ang = Vector(0,0,0), Angle(0,0,0)
			local m = vm:GetBoneMatrix(bone)
			if (m) then
				pos, ang = m:GetTranslation(), m:GetAngle()
			end
			
			if (self.ViewModelFlip) then
				ang.r = -ang.r // Fixes mirrored models
			end
			
			if (v.type == "Model" and ValidEntity(model)) then

				model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
				ang:RotateAroundAxis(ang:Up(), v.angle.y)
				ang:RotateAroundAxis(ang:Right(), v.angle.p)
				ang:RotateAroundAxis(ang:Forward(), v.angle.r)

				model:SetAngles(ang)
				model:SetModelScale(v.size)
				
				if (v.material == "") then
					model:SetMaterial("")
				elseif (model:GetMaterial() != v.material) then
					model:SetMaterial( v.material )
				end
				
				if (v.skin != model:GetSkin()) then
					model:SetSkin(v.skin)
				end
				
				for k, v in pairs( v.bodygroup ) do
					if (model:GetBodygroup(k) != v) then
						model:SetBodygroup(k, v)
					end
				end
				
				if (v.surpresslightning) then
					render.SuppressEngineLighting(true)
				end
				
				render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
				render.SetBlend(v.color.a/255)
				model:DrawModel()
				render.SetBlend(1)
				render.SetColorModulation(1, 1, 1)
				
				if (v.surpresslightning) then
					render.SuppressEngineLighting(false)
				end
				
			elseif (v.type == "Sprite" and sprite) then
				
				local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
				render.SetMaterial(sprite)
				render.DrawSprite(drawpos, v.size.x, v.size.y, v.color)
				
			elseif (v.type == "Quad") then
			
				local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
				ang:RotateAroundAxis(ang:Up(), v.angle.y)
				ang:RotateAroundAxis(ang:Right(), v.angle.p)
				ang:RotateAroundAxis(ang:Forward(), v.angle.r)
				
				cam.Start3D2D(drawpos, ang, v.size)
					draw.RoundedBox( 0, -20, -20, 40, 40, Color(200,0,0,100) )
					surface.SetDrawColor( 255, 255, 255, 100 )
					surface.DrawOutlinedRect( -20, -20, 40, 40 )
					draw.SimpleTextOutlined("12pt arial","12ptFont",0, -12, Color(255,255,255,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP, 1, Color(0,0,0,255))
					draw.SimpleTextOutlined("40x40 box","12ptFont",0, 2, Color(255,255,255,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP, 1, Color(0,0,0,255))
					surface.SetDrawColor( 0, 255, 0, 230 )
					surface.DrawLine( 0, 0, 0, 8 )
					surface.DrawLine( 0, 0, 8, 0 )
				cam.End3D2D()

			end
			
		end
		
	end
	
	/********************************
		All worldmodel drawing science
	*********************************/
	local wRenderOrder = nil
	function SWEP:DrawWorldModel()
		
		local wm = world_model
		if !ValidEntity(wm) then return end
		
		if (!wRenderOrder) then

			wRenderOrder = {}

			for k, v in pairs( w_models ) do
				if (v.type == "Model") then
					table.insert(wRenderOrder, 1, k)
				elseif (v.type == "Sprite" or v.type == "Quad") then
					table.insert(wRenderOrder, k)
				end
			end

		end
		
		local opos, oang = self:GetPos(), self:GetAngles()
		local bone_ent
		
		if (ValidEntity(self.Owner)) then
			self:SetColor(255,255,255,255)
			wm:SetNoDraw(true)
			if (self.Owner:GetActiveWeapon() != self.Weapon) then return end
			wm:SetParent(self.Owner)
			if (self.ShowWorldModel) then
				wm:DrawModel()
			end
			bone_ent = self.Owner
		else
			// this only happens if the weapon is dropped, which shouldn't happen normally.
			self:SetColor(255,255,255,0)
			wm:SetNoDraw(false) // else DrawWorldModel stops being called for some reason
			wm:SetParent(self)
			wm:SetPos(opos)
			wm:SetAngles(oang)
			if (self.ShowWorldModel) then
				wm:DrawModel()
			end
		
			// the reason that we don't always use this bone is because it lags 1 frame behind the player's right hand bone when held
			bone_ent = wm
		end
		
		/* BASE CODE FOR NEW SWEPS */
		/*self:DrawModel()
		if (ValidEntity(self.Owner)) then
			bone_ent = self.Owner
		else
			// when the weapon is dropped
			bone_ent = self
		end*/
		
		local bone = bone_ent:LookupBone("ValveBiped.Bip01_R_Hand")
		if (bone) then
			local m = bone_ent:GetBoneMatrix(bone)
			if (m) then
				opos, oang = m:GetTranslation(), m:GetAngle()
			end
		end
		
		for k, name in pairs( wRenderOrder ) do
		
			local v = w_models[name]
			if (!v) then wRenderOrder = nil break end
		
			local model = v.modelEnt
			local sprite = v.spriteMaterial

			local pos, ang = Vector(opos.x, opos.y, opos.z), Angle(oang.p, oang.y, oang.r)

			if (v.type == "Model" and ValidEntity(model)) then

				model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
				ang:RotateAroundAxis(ang:Up(), v.angle.y)
				ang:RotateAroundAxis(ang:Right(), v.angle.p)
				ang:RotateAroundAxis(ang:Forward(), v.angle.r)

				model:SetAngles(ang)
				model:SetModelScale(v.size)
				
				if (v.material == "") then
					model:SetMaterial("")
				elseif (model:GetMaterial() != v.material) then
					model:SetMaterial( v.material )
				end
				
				if (v.skin != model:GetSkin()) then
					model:SetSkin(v.skin)
				end
				
				for k, v in pairs( v.bodygroup ) do
					if (model:GetBodygroup(k) != v) then
						model:SetBodygroup(k, v)
					end
				end
				
				if (v.surpresslightning) then
					render.SuppressEngineLighting(true)
				end
				
				render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
				render.SetBlend(v.color.a/255)
				model:DrawModel()
				render.SetBlend(1)
				render.SetColorModulation(1, 1, 1)
				
				if (v.surpresslightning) then
					render.SuppressEngineLighting(false)
				end
				
			elseif (v.type == "Sprite" and sprite) then
				
				local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
				render.SetMaterial(sprite)
				render.DrawSprite(drawpos, v.size.x, v.size.y, v.color)
				
			elseif (v.type == "Quad") then
			
				local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
				ang:RotateAroundAxis(ang:Up(), v.angle.y)
				ang:RotateAroundAxis(ang:Right(), v.angle.p)
				ang:RotateAroundAxis(ang:Forward(), v.angle.r)
				
				cam.Start3D2D(drawpos, ang, v.size)
					draw.RoundedBox( 0, -20, -20, 40, 40, Color(200,0,0,100) )
					surface.SetDrawColor( 255, 255, 255, 100 )
					surface.DrawOutlinedRect( -20, -20, 40, 40 )
					draw.SimpleTextOutlined("12pt arial","12ptFont",0, -12, Color(255,255,255,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP, 1, Color(0,0,0,255))
					draw.SimpleTextOutlined("40x40 box","12ptFont",0, 2, Color(255,255,255,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP, 1, Color(0,0,0,255))
					surface.SetDrawColor( 0, 255, 0, 230 )
					surface.DrawLine( 0, 0, 0, 8 )
					surface.DrawLine( 0, 0, 8, 0 )
				cam.End3D2D()

			end
			
		end
		
	end
	
	function SWEP:Holster()
		useThirdPerson = false
		return true
	end
	
	function SWEP:DrawHUD()

		if (self.Frame and self.Frame:IsVisible()) then
		
			local text = ""
			if (useThirdPerson) then
				text = "Hold right mouse and drag to rotate. Additionally hold E key to zoom."
			else
				text = "Hold right mouse and drag to adjust ironsights (mode: "..cur_drag_mode..")"
			end
			draw.SimpleTextOutlined(text, "default", ScrW()/2, ScrH()/4, Color(255,255,255,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP, 1, Color(20,20,20,255))
			
		end
	end
	
	/***************************
				Menu
	***************************/
	local function CreateMenu( preset )
		
		local wep = GetSWEP( LocalPlayer() )
		if !ValidEntity(wep) then return nil end
		
		save_data = table.Copy(save_data_template)
		
		if (preset) then
			// use the preset
			for k, v in pairs( preset ) do
				if (save_data[k] == nil) then continue end // don't read what's not in the template
				save_data[k] = v
			end
		end
		
		/****** Create model browser *****/

		// callback = function( selected_model )
		local function OpenBrowser( current, browse_type, callback )
			
			browser_callback = callback
			wep.Frame:SetVisible( false )
			
			if (browse_type == "model" and modelbrowser) then
				modelbrowser:SetVisible(true)
				modelbrowser:MakePopup()
				modelbrowser_list.OnRowSelected(nil,nil,current)
				return
			elseif (browse_type == "material" and matbrowser) then
				matbrowser:SetVisible(true)
				matbrowser:MakePopup()
				matbrowser_list.OnRowSelected(nil,nil,current)
				return
			end
		
			local browser = vgui.Create("DFrame")
			browser:SetSize( 300, 580 )
			browser:SetPos( ScrW()/4 - 150, ScrH()/2 - 250 )
			browser:SetDraggable( true )
			browser:ShowCloseButton( false )
			browser:SetSizable( false )
			browser:SetDeleteOnClose( false )

			if (browse_type == "model") then
				browser:SetTitle( "Model browser" )
				modelbrowser = browser
			elseif (browse_type == "material") then
				browser:SetTitle( "Material browser" )
				matbrowser = browser
			end
			
			local tree = vgui.Create( "DTree", browser )
			tree:SetPos( 5, 30 )
			tree:SetSize( browser:GetWide() - 10, browser:GetTall()-355 )

			local nodelist = {}
			local filecache = {}
			local checked = {}
			
			local modlist = vgui.Create("DListView", browser)
			modlist:SetPos( 5, browser:GetTall() - 320 )
			modlist:SetSize( browser:GetWide() - 10, 200 )
			modlist:SetMultiSelect(false)
			modlist:SetDrawBackground(true)
			if (browse_type == "model") then
				modlist:AddColumn("Model")
			elseif (browse_type == "material") then
				modlist:AddColumn("Material")
			end
			
			local modzoom = 32
			local modview 
			
			if (browse_type == "model") then
				modview = vgui.Create("DModelPanel", browser)
				modview:SetModel("")
				modview:SetCamPos( Vector(modzoom,modzoom,modzoom/2) )
				modview:SetLookAt( Vector( 0, 0, 0 ) )
			elseif (browse_type == "material") then
				modview = vgui.Create("DImage", browser)
				modview:SetImage("")
			end
			
			modview:SetPos( 5, browser:GetTall() - 115)
			modview:SetSize(110,110)

			local mdlabel = vgui.Create("DLabel", browser)
			mdlabel:SetPos( 120, browser:GetTall() - 115 )
			mdlabel:SetSize( browser:GetWide() - 125, 20 )
			mdlabel:SetText( current )

			if (browse_type == "model") then
			
				local zoomslider = vgui.Create( "DNumSlider", browser)
				zoomslider:SetPos( 120, browser:GetTall() - 90 )
				zoomslider:SetWide( browser:GetWide() - 125 )
				zoomslider:SetText( "Zoom" )
				zoomslider:SetMin( 16 )
				zoomslider:SetMax( 256 )
				zoomslider:SetDecimals( 0 )
				zoomslider:SetValue( modzoom )
				zoomslider.OnValueChanged = function( panel, value )
					local modzoom = tonumber(value)
					modview:SetCamPos( Vector(modzoom,modzoom,modzoom/2) )
				end
				local areazm = zoomslider:GetTextArea()
				areazm.OnTextChanged = function() zoomslider:SetValue(areazm:GetValue()) end
				
			end
			
			local selected = ""
			
			modlist.OnRowSelected = function( panel, line, override )
				if (type(override) != "string") then override = nil end // for some reason the list itself throws a panel at it in the callback
				local path = override or modlist:GetLine(line):GetValue(1)

				if (browse_type == "model") then
					modview:SetModel(path)
				elseif (browse_type == "material") then
					if (path:sub( 1, 10 ) == "materials/") then
						path = path:sub( 11 ) // removes the "materials/" part
					end
					path = path:gsub( "%.vmt", "" )
					modview:SetImage(path)
				end

				mdlabel:SetText(path)
				selected = path
			end
			
			// set the default
			modlist.OnRowSelected(nil,nil,current)
			if (browse_type == "model") then
				modelbrowser_list = modlist
			elseif (browse_type == "material") then
				matbrowser_list = modlist
			end

			local choosebtn = vgui.Create("DButton", browser)
			choosebtn:SetPos( 120, browser:GetTall() - 40 )
			choosebtn:SetSize( browser:GetWide() - 125, 18 )
			if (browse_type == "model") then
				choosebtn:SetText("DO WANT THIS MODEL")
			elseif (browse_type == "material") then
				choosebtn:SetText("DO WANT THIS MATERIAL")
			end
			
			choosebtn.DoClick = function()
				if (browser_callback) then
					pcall(browser_callback, selected)
				end
				if (wep.Frame) then
					wep.Frame:SetVisible(true)
				end
				browser:Close()
			end
			
			local cancelbtn = vgui.Create("DButton", browser)
			cancelbtn:SetPos( 120, browser:GetTall() - 20 )
			cancelbtn:SetSize( browser:GetWide() - 125, 16 )
			cancelbtn:SetText("cancel")
			cancelbtn.DoClick = function()
				if (wep.Frame) then
					wep.Frame:SetVisible(true)
				end
				browser:Close()
			end
			
			local LoadDirectories
			local AddNode = function( base, dir, tree_override )
				
				local newpath = base.."/"..dir
				local basenode = nodelist[base]
				
				if (tree_override) then
					newpath = dir
					basenode = tree_override
				end
				
				if (!basenode) then
					print("No base node for \""..tostring(base).."\", \""..tostring(dir).."\", "..tostring(tree_override))
				end
				
				nodelist[newpath] = basenode:AddNode( dir )
				nodelist[newpath].DoClick = function()
					LoadDirectories( newpath )
					modlist:Clear()
					modlist:SetVisible(true)
					
					if (filecache[newpath]) then
						for k, f in pairs(filecache[newpath]) do
							modlist:AddLine(f)
						end
					else
						filecache[newpath] = {}
						local files
						if (newpath:sub(1,9) == "materials") then
							files = file.Find("../"..newpath.."/*.vmt")
						else
							files = file.Find("../"..newpath.."/*.mdl")
						end
						table.sort(files)
						for k, f in pairs(files) do
							local newfilepath = newpath.."/"..f
							modlist:AddLine(newfilepath)
							table.insert(filecache[newpath], newfilepath)
						end
					end
				end
					
			end
			
			if (browse_type == "model") then
				AddNode( "", "models", tree )
			elseif (browse_type == "material") then
				AddNode( "", "materials", tree )
			end
			
			LoadDirectories = function( v )
				
				if (checked[v]) then return end
				newdirs = file.FindDir("../"..v.."/*")
				table.insert(checked, v)
				
				table.sort(newdirs)
				
				for _, dir in pairs(newdirs) do
					AddNode( v, dir )
				end

			end
			
			if (browse_type == "model") then
				LoadDirectories( "models" )
			elseif (browse_type == "material") then
				LoadDirectories( "materials" )
			end
		
			browser:SetVisible( true )
			browser:MakePopup()
			
		end
		
		/****************************************/
		
		// Now for the actual menu:		
		local f = vgui.Create("DFrame")
		f:SetSize( 300, 580 )
		f:SetPos( ScrW()/4 - 150, ScrH()/2 - 250 )
		f:SetTitle( "SWEP Construction Kit" )
		f:SetDraggable( true )
		f:ShowCloseButton( true )
		f:SetSizable( false )
		f:SetDeleteOnClose( false )

		local tbtn = vgui.Create( "DButton", f )
		tbtn:SetPos( 155, 2 )
		tbtn:SetSize( 120, 18 )
		tbtn:SetText( "Toggle thirdperson" )
		tbtn.DoClick = function()
			RunConsoleCommand("swepck_togglethirdperson")
		end
		
		local tab = vgui.Create( "DPropertySheet", f )
		tab:SetPos( 5, 30 )
		tab:SetSize( f:GetWide() - 10, f:GetTall()-35 )
		
		local ptool = vgui.Create("DPanel", tab)
		ptool.Paint = function() surface.SetDrawColor(50,50,50,255) surface.DrawRect(0,0,ptool:GetWide(),ptool:GetTall()) end
		local pweapon = vgui.Create("DPanel", tab)
		pweapon.Paint = function() surface.SetDrawColor(50,50,50,255) surface.DrawRect(0,0,pweapon:GetWide(),pweapon:GetTall()) end
		local pironsight = vgui.Create("DPanel", tab)
		pironsight.Paint = function() surface.SetDrawColor(50,50,50,255) surface.DrawRect(0,0,pironsight:GetWide(),pironsight:GetTall()) end
		local pmodels = vgui.Create("DPanel", tab)
		pmodels.Paint = function() surface.SetDrawColor(50,50,50,255) surface.DrawRect(0,0,pmodels:GetWide(),pmodels:GetTall()) end
		local pwmodels = vgui.Create("DPanel", tab)
		pwmodels.Paint = function() surface.SetDrawColor(50,50,50,255) surface.DrawRect(0,0,pwmodels:GetWide(),pwmodels:GetTall()) end
		
		tab:AddSheet( "Tool", ptool, "gui/silkicons/wrench", false, false, "Modify tool settings" )
		tab:AddSheet( "Weapon", pweapon, "gui/silkicons/bomb", false, false, "Modify weapon settings" )
		tab:AddSheet( "Ironsights", pironsight, "gui/silkicons/wrench", false, false, "Modify ironsights" )
		tab:AddSheet( "VModels", pmodels, "gui/silkicons/brick_add", false, false, "Modify view models" )
		tab:AddSheet( "WModels", pwmodels, "gui/silkicons/brick_add", false, false, "Modify world models" )
		
		/*****************
			Tool page
		*****************/
		local addy = 10
		
		// ***** Animations *****
		
		local alabel = vgui.Create( "DLabel", ptool )
		alabel:SetPos( 10, addy )
		alabel:SetSize( 240, 20 )
		alabel:SetText( "Play animation (BROKEN):" )
		
		addy = addy + 25
		
		local aabtn = vgui.Create( "DButton", ptool )
		aabtn:SetPos( 10, addy )
		aabtn:SetSize( 120, 18 )
		aabtn:SetText( "Primary Attack" )
		aabtn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_PRIMARYATTACK)
			wep:ResetSequenceInfo()
			wep:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
			LocalPlayer():SetAnimation(PLAYER_ATTACK1)
		end
		
		local arbtn = vgui.Create( "DButton", ptool )
		arbtn:SetPos( 140, addy )
		arbtn:SetSize( 120, 18 )
		arbtn:SetText( "Reload" )
		arbtn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_RELOAD)
			wep:SendWeaponAnim(ACT_VM_RELOAD)
			LocalPlayer():SetAnimation(PLAYER_RELOAD)
		end
		
		addy = addy + 20
		
		local m1btn = vgui.Create( "DButton", ptool )
		m1btn:SetPos( 10, addy )
		m1btn:SetSize( 120, 18 )
		m1btn:SetText( "Melee 1" )
		m1btn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_MISSCENTER)
			wep:SendWeaponAnim(ACT_VM_MISSCENTER)
			LocalPlayer():SetAnimation(PLAYER_ATTACK1)
		end
		
		local m2btn = vgui.Create( "DButton", ptool )
		m2btn:SetPos( 140, addy )
		m2btn:SetSize( 120, 18 )
		m2btn:SetText( "Melee 2" )
		m2btn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_HITCENTER)
			wep:SendWeaponAnim(ACT_VM_HITCENTER)
			LocalPlayer():SetAnimation(PLAYER_ATTACK1)
		end
		
		addy = addy + 20
		
		local gcbtn = vgui.Create( "DButton", ptool )
		gcbtn:SetPos( 10, addy )
		gcbtn:SetSize( 120, 18 )
		gcbtn:SetText( "Grenade pull (CSS)" )
		gcbtn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_PULLPIN)
			wep:SendWeaponAnim(ACT_VM_PULLPIN)
		end
		
		local ghbtn = vgui.Create( "DButton", ptool )
		ghbtn:SetPos( 140, addy )
		ghbtn:SetSize( 120, 18 )
		ghbtn:SetText( "Grenade pull (HL2)" )
		ghbtn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_PULLBACK_HIGH)
			wep:SendWeaponAnim(ACT_VM_PULLBACK_HIGH)
		end
		
		addy = addy + 20
		
		local wdbtn = vgui.Create( "DButton", ptool )
		wdbtn:SetPos( 10, addy )
		wdbtn:SetSize( 120, 18 )
		wdbtn:SetText( "Draw" )
		wdbtn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_DRAW)
			wep:SendWeaponAnim(ACT_VM_DRAW)
		end
		
		local tgbtn = vgui.Create( "DButton", ptool )
		tgbtn:SetPos( 140, addy )
		tgbtn:SetSize( 120, 18 )
		tgbtn:SetText( "Throw grenade" )
		tgbtn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_THROW)
			wep:SendWeaponAnim(ACT_VM_THROW)
			LocalPlayer():SetAnimation(PLAYER_ATTACK1)
		end
		
		addy = addy + 20
		
		local idlbtn = vgui.Create( "DButton", ptool )
		idlbtn:SetPos( 10, addy )
		idlbtn:SetSize( 120, 18 )
		idlbtn:SetText( "Idle" )
		idlbtn.DoClick = function()
			RunConsoleCommand("swepck_playanimation", ACT_VM_IDLE)
			wep:SendWeaponAnim(ACT_VM_IDLE)
		end
		
		addy = addy + 45
		
		// ***** Settings saving / loading *****
		local note_x = 10
		local note_y = addy + 75
		
		local function CreateSettingsNote( text )
			local templabel = vgui.Create( "DLabel" )
			templabel:SetText( text )
			templabel:SetSize( 260, 20 )

			local notif = vgui.Create( "DNotify" , ptool )
			notif:SetPos( note_x, note_y )
			notif:SetSize( 260, 20 )
			notif:SetLife( 5 )
			notif:AddItem(templabel)
		end
		
		local selabel = vgui.Create( "DLabel", ptool )
		selabel:SetPos( 10, addy )
		selabel:SetSize( 200, 20 )
		selabel:SetText( "Configuration:" )
		
		addy = addy + 25
		
		local satext = vgui.Create( "DTextEntry", ptool)
		satext:SetPos( 95, addy )
		satext:SetSize( 170, 20 )
		satext:SetMultiline(false)
		satext:SetText( "save1" )
		
		local sabtn = vgui.Create( "DButton", ptool )
		sabtn:SetPos( 10, addy )
		sabtn:SetSize( 80, 20 )
		sabtn:SetText( "Save as:" )
		sabtn.DoClick = function()
		
			if !ValidEntity(wep) then return end
				
			local text = string.Trim(satext:GetValue())
			if (text == "") then return end
			
			// collect all save data
			save_data.v_models = table.Copy(v_models)
			save_data.w_models = table.Copy(w_models)
			save_data.v_bonescales = table.Copy(v_bonescales)
			// remove caches
			for k, v in pairs(save_data.v_models) do
				v.createdModel = nil
				v.createdSprite = nil
			end
			for k, v in pairs(save_data.w_models) do
				v.createdModel = nil
				v.createdSprite = nil
			end
			save_data.ViewModelFlip = wep.ViewModelFlip
			save_data.ViewModel = wep.ViewModel
			save_data.CurWorldModel = wep.CurWorldModel
			save_data.ViewModelFOV = wep.ViewModelFOV
			save_data.HoldType = wep.HoldType
			save_data.IronSightsEnabled = wep:GetIronSights()
			save_data.IronSightsPos, save_data.IronSightsAng = wep:GetIronSightCoordination()
			save_data.ShowViewModel = wep.ShowViewModel
			save_data.ShowWorldModel = wep.ShowWorldModel
			
			local filename = "swep_construction_kit/"..text..".txt"
			
			local succ, val = pcall(glon.encode, save_data)
			if (!succ) then LocalPlayer():ChatPrint("Failed to encode settings!") return end
			
			file.Write(filename, val)
			LocalPlayer():ChatPrint("Saved file \""..text.."\"!")
		end
		
		addy = addy + 25
		
		local lftext = vgui.Create( "DTextEntry", ptool)
		lftext:SetPos( 95, addy )
		lftext:SetSize( 170, 20 )
		lftext:SetMultiline(false)
		lftext:SetText( "save1" )
		
		local lfbtn = vgui.Create( "DButton", ptool )
		lfbtn:SetPos( 10, addy )
		lfbtn:SetSize( 80, 20 )
		lfbtn:SetText( "Load file:" )
		lfbtn.DoClick = function()
			local text = string.Trim(lftext:GetValue())
			if (text == "") then return end
			
			local filename = "swep_construction_kit/"..text..".txt"
			
			if (!file.Exists (filename)) then
				CreateSettingsNote( "No such file exists!" )
				return
			end
			
			local glondata = file.Read(filename)
			local succ, new_preset = pcall(glon.decode, glondata)
			if (!succ) then LocalPlayer():ChatPrint("Failed to load settings!") return end
			
			wep:CleanMenu()
			wep:OpenMenu( new_preset )
			LocalPlayer():ChatPrint("Loaded file \""..text.."\"!")
		end
		
		// link to FP thread
		
		addy = addy + 45
		
		local alabel = vgui.Create( "DLabel", ptool )
		alabel:SetPos( 10, addy )
		alabel:SetSize( 240, 20 )
		alabel:SetText( "Link to tool tutorial (copy-paste to browser):" )
		
		addy = addy + 25
		
		local tutltext = vgui.Create( "DTextEntry", ptool)
		tutltext:SetPos( 10, addy )
		tutltext:SetSize( 240, 20 )
		tutltext:SetMultiline(false)
		tutltext:SetEditable(true)
		tutltext:SetText( "http://tinyurl.com/swepkit" )
		
		
		/*****************
			Weapon page
		*****************/
		local addy = 10
		
		local next_v_model = ""
		
		// Weapon model
		local vlabel = vgui.Create( "DLabel", pweapon )
		vlabel:SetPos( 10, addy )
		vlabel:SetSize( 80, 20 )
		vlabel:SetText( "View model:" )
		
		local vtext = vgui.Create( "DTextEntry", pweapon)
		vtext:SetPos( 85, addy )
		vtext:SetSize( 160, 20 )
		vtext:SetMultiline(false)
		vtext.OnTextChanged = function()
			local newmod = string.gsub(vtext:GetValue(), ".mdl", "")
			RunConsoleCommand("swepck_viewmodel", newmod)
			
			// clear view model additions
			if (newmod != next_v_model and file.Exists("../"..newmod..".mdl")) then
				next_v_model = newmod
				ClearViewModels()
				RefreshViewModelBoneScales()
			end
			
		end
		vtext:SetText( save_data.ViewModel )
		vtext:OnTextChanged()
		
		local vtbtn = vgui.Create( "DButton", pweapon )
		vtbtn:SetPos( 245, addy )
		vtbtn:SetSize( 20, 20 )
		vtbtn:SetText("...")
		vtbtn.DoClick = function()
			OpenBrowser( wep.ViewModel, "model", function( val ) vtext:SetText(val) vtext:OnTextChanged() end )
		end
		
		addy = addy + 25
		
		local wlabel = vgui.Create( "DLabel", pweapon )
		wlabel:SetPos( 10, addy )
		wlabel:SetSize( 80, 20 )
		wlabel:SetText( "World model:" )
		
		local wtext = vgui.Create( "DTextEntry", pweapon)
		wtext:SetPos( 85, addy )
		wtext:SetSize( 160, 20 )
		wtext:SetMultiline(false)
		wtext.OnTextChanged = function()
			local newmod = string.gsub(wtext:GetValue(), ".mdl", "")
			RunConsoleCommand("swepck_worldmodel", newmod)
			
			// clear world model additions
			if (newmod != cur_wmodel) then
				ClearWorldModels()
			end
			
		end
		wtext:SetText( save_data.CurWorldModel )
		wtext:OnTextChanged()
		
		local wtbtn = vgui.Create( "DButton", pweapon )
		wtbtn:SetPos( 245, addy )
		wtbtn:SetSize( 20, 20 )
		wtbtn:SetText("...")
		wtbtn.DoClick = function()
			OpenBrowser( wep.CurWorldModel, "model", function( val ) wtext:SetText(val) wtext:OnTextChanged() end )
		end
		
		addy = addy + 30
		
		// Weapon hold type
		local hlabel = vgui.Create( "DLabel", pweapon )
		hlabel:SetPos( 10, addy )
		hlabel:SetSize( 150, 20 )
		hlabel:SetText( "Hold type (3rd person):" )
		
		local hbox = vgui.Create( "DMultiChoice", pweapon )
		hbox:SetPos( 140, addy )
		hbox:SetSize( 125, 20 )
		hbox:SetEditable( false )
		for k, v in pairs( wep:GetHoldTypes() ) do
			hbox:AddChoice( v )
		end
		hbox.OnSelect = function(panel,index,value)
			if (!value) then return end
			wep:SetWeaponHoldType( value )
			wep.HoldType = value
			RunConsoleCommand("swepck_setholdtype", value)
		end
		hbox:SetText( save_data.HoldType )
		hbox.OnSelect( nil, nil, save_data.HoldType )
		
		addy = addy + 30
		
		// Show viewmodel
		local vhbox = vgui.Create( "DCheckBoxLabel", pweapon )
		vhbox:SetPos( 10, addy )
		vhbox:SetSize( 150, 20 )
		vhbox:SetText( "Show view model" )
		vhbox.OnChange = function()
			wep.ShowViewModel = vhbox:GetChecked()
			if (wep.ShowViewModel) then
				LocalPlayer():GetViewModel():SetColor(255,255,255,255)
			else
				LocalPlayer():GetViewModel():SetColor(255,255,255,1) // we set the alpha to 1 because else ViewModelDrawn stops being called
			end
		end
		if (save_data.ShowViewModel) then vhbox:SetValue(1)
		else vhbox:SetValue(0) end
		
		addy = addy + 30
		
		// Show worldmodel
		local whbox = vgui.Create( "DCheckBoxLabel", pweapon )
		whbox:SetPos( 10, addy )
		whbox:SetSize( 150, 20 )
		whbox:SetText( "Show world model" )
		whbox.OnChange = function()
			wep.ShowWorldModel = whbox:GetChecked()
		end
		if (save_data.ShowWorldModel) then whbox:SetValue(1)
		else whbox:SetValue(0) end
		
		addy = addy + 30
		
		// Flip viewmodel
		local fcbox = vgui.Create( "DCheckBoxLabel", pweapon )
		fcbox:SetPos( 10, addy )
		fcbox:SetSize( 150, 20 )
		fcbox:SetText( "Flip viewmodel" )
		fcbox.OnChange = function()
			wep.ViewModelFlip = fcbox:GetChecked()
		end
		if (save_data.ViewModelFlip) then fcbox:SetValue(1)
		else fcbox:SetValue(0) end
		
		addy = addy + 30
		
		// View model FOV slider
		local fovslider = vgui.Create( "DNumSlider", pweapon )
		fovslider:SetPos( 10, addy )
		fovslider:SetWide( 260 )
		fovslider:SetText( "View model FOV" )
		fovslider:SetMin( 20 )
		fovslider:SetMax( 140 )
		fovslider:SetDecimals( 0 )
		fovslider.OnValueChanged = function( panel, value )
			wep.ViewModelFOV = tonumber(value)
			RunConsoleCommand("swepck_viewmodelfov", value)
		end
		fovslider:SetValue( save_data.ViewModelFOV )
		
		addy = addy + 50
		
		// View model bone scaling
		local vsbonelabel = vgui.Create( "DLabel", pweapon )
		vsbonelabel:SetPos( 10, addy )
		vsbonelabel:SetSize( 250, 20 )
		vsbonelabel:SetText( "View model bone scales (name/(xyz)/y/z):" )
		
		// clean up scale table (remove unnecessary entries)
		local toremove = {}
		for k, v in pairs(save_data.v_bonescales) do
			if (v == Vector(1,1,1)) then save_data.v_bonescales[k] = nil end
		end
		
		local curbone = ""
		local prebone = table.GetFirstKey(save_data.v_bonescales)

		if (prebone) then 
			curbone = prebone
			v_bonescales = table.Copy(save_data.v_bonescales)
		else
			v_bonescales = {} // reset bonescales table
		end
		
		local resbtn = vgui.Create( "DButton", pweapon )
		resbtn:SetPos( 220, addy )
		resbtn:SetSize( 50, 20 )
		resbtn:SetText("Reset")
		
		addy = addy + 25
		
		local vsbonebox = vgui.Create( "DMultiChoice", pweapon )
		vsbonebox:SetPos( 10, addy )
		vsbonebox:SetSize( 100, 20 )
		vsbonebox:SetEditable( false )
		
		local vsxwang = vgui.Create( "DNumberWang", pweapon )
		vsxwang:SetPos( 110, addy-2 )
		vsxwang:SetSize( 52, 24 )
		vsxwang:SetMin( 0.01 )
		vsxwang:SetMax( 3 )
		vsxwang:SetDecimals( 3 )
		local areavx = vsxwang:GetTextArea()
		areavx.OnTextChanged = function() vsxwang:SetValue(tonumber(areavx:GetValue())) end
		
		local vsywang = vgui.Create( "DNumberWang", pweapon )
		vsywang:SetPos( 165, addy )
		vsywang:SetSize( 50, 20 )
		vsywang:SetMin( 0.01 )
		vsywang:SetMax( 3 )
		vsywang:SetDecimals( 3 )
		vsywang.OnValueChanged = function( p, value ) 
			if (curbone != "") then 
				v_bonescales[curbone].y = tonumber(value)
			end
		end
		local areavy = vsywang:GetTextArea()
		areavy.OnTextChanged = function() vsywang:SetValue(tonumber(areavy:GetValue())) end
		
		local vszwang = vgui.Create( "DNumberWang", pweapon )
		vszwang:SetPos( 220, addy )
		vszwang:SetSize( 50, 20 )
		vszwang:SetMin( 0.01 )
		vszwang:SetMax( 3 )
		vszwang:SetDecimals( 3 )
		vszwang.OnValueChanged = function( p, value ) 
			if (curbone != "") then 
				v_bonescales[curbone].z = tonumber(value)
			end 
		end
		local areavz = vszwang:GetTextArea()
		areavz.OnTextChanged = function() vszwang:SetValue(tonumber(areavz:GetValue())) end

		// make the x numberwang set the total size
		vsxwang.OnValueChanged = function( p, value )
			if (curbone == "") then return end
			vszwang:SetValue( value )
			vsywang:SetValue( value )
			v_bonescales[curbone].x = tonumber(value)
		end
		
		vsbonebox.OnSelect = function( p, index, value )
			curbone = value
			if (!v_bonescales[curbone]) then
				v_bonescales[curbone] = Vector(1,1,1)
			end
			
			local loady = v_bonescales[curbone].y
			local loadz = v_bonescales[curbone].z
			
			vsxwang:SetValue( v_bonescales[curbone].z )
			vsywang:SetValue( loady )
			vszwang:SetValue( loadz )
		end
		vsbonebox:SetText( curbone )
		
		local val_x, val_y, val_z = 1, 1, 1
		if (v_bonescales[curbone]) then
			val_x = v_bonescales[curbone].x
			val_y = v_bonescales[curbone].y
			val_z = v_bonescales[curbone].z			
		end			
		vsxwang:SetValue( val_x )
		vsywang:SetValue( val_y )
		vszwang:SetValue( val_z )
		
		timer.Simple(2, function()
			local option = PopulateBoneList( vsbonebox )
			if (option and curbone == "") then 
				vsbonebox:ChooseOptionID(1)
			end
		end)
		
		resbtn.DoClick = function()
			v_bonescales = {}
			if (curbone == "") then return end
			v_bonescales[curbone] = Vector(1,1,1)
			vsxwang:SetValue(1)
		end
		
		v_modelbonebox = vsbonebox
		
		addy = addy + 30
		
		local wpbtn = vgui.Create( "DButton", pweapon )
		wpbtn:SetPos( 10, addy )
		wpbtn:SetSize( 260, 30 )
		wpbtn:SetText( "Print weapon code to console" )
		wpbtn.DoClick = function()
			MsgN("*********************************************")
			MsgN(GetWeaponPrintText(wep))
			MsgN("*********************************************")
			LocalPlayer():ChatPrint("Code printed to console!")
		end
		
		addy = addy + 35
		
		local wpcbtn = vgui.Create( "DButton", pweapon )
		wpcbtn:SetPos( 10, addy )
		wpcbtn:SetSize( 260, 30 )
		wpcbtn:SetText( "Copy weapon code to clipboard" )
		wpcbtn.DoClick = function()
			SetClipboardText(GetWeaponPrintText(wep))
			LocalPlayer():ChatPrint("Code copied to clipboard!")
		end
		
		
		/*********************
			Ironsights page
		*********************/
		addy = 10
		
		local icbox = vgui.Create( "DCheckBoxLabel", pironsight )
		icbox:SetPos( 10, addy )
		icbox:SetSize( 150, 20 )
		icbox:SetText( "Enable ironsights" )
		icbox.OnChange = function()
			if (wep:GetIronSights() != icbox:GetChecked()) then
				RunConsoleCommand("swepck_toggleironsights")
			end
		end
		if (save_data.IronSightsEnabled) then icbox:SetValue(1)
		else icbox:SetValue(0) end
	
		local ribtn = vgui.Create( "DButton", pironsight )
		ribtn:SetPos( 140, addy )
		ribtn:SetSize( 125, 20 )
		ribtn:SetText( "Reset ironsights" )
		ribtn.DoClick = function()
			wep:ResetIronSights()
		end

		addy = addy + 30
		
		local modlabel = vgui.Create( "DLabel", pironsight )
		modlabel:SetPos( 10, addy )
		modlabel:SetSize( 100, 20 )
		modlabel:SetText( "Drag mode:" )
		
		local drbox = vgui.Create( "DMultiChoice", pironsight )
		drbox:SetPos( 140, addy )
		drbox:SetSize( 125, 20 )
		drbox:SetEditable( false )
		drbox:SetText( cur_drag_mode )
		for k, v in pairs( drag_modes ) do
			drbox:AddChoice( k )
		end
		drbox.OnSelect = function(panel,index,value)
			local modes = drag_modes[value]
			cur_drag_mode = value
			for k, v in pairs( ir_drag ) do
				v[1] = table.HasValue( modes, k ) // set the drag modus
			end
		end
		
		addy = addy + 30
		
		local ixslider = vgui.Create( "DNumSlider", pironsight )
		ixslider:SetPos( 10, addy )
		ixslider:SetWide( 260 )
		ixslider:SetText( "Translate x" )
		ixslider:SetMin( -20 )
		ixslider:SetMax( 20 )
		ixslider:SetDecimals( 3 )
		ixslider:SetConVar( "_sp_ironsight_x" )
		ixslider:SetValue( save_data.IronSightsPos.x )
		local areaix = ixslider:GetTextArea()
		areaix.OnTextChanged = function() RunConsoleCommand("_sp_ironsight_x",areaix:GetValue()) end
			
		addy = addy + 45
		
		local iyslider = vgui.Create( "DNumSlider", pironsight )
		iyslider:SetPos( 10, addy )
		iyslider:SetWide( 260 )
		iyslider:SetText( "Translate y" )
		iyslider:SetMin( -20 )
		iyslider:SetMax( 20 )
		iyslider:SetDecimals( 3 )
		iyslider:SetConVar( "_sp_ironsight_y" )
		iyslider:SetValue( save_data.IronSightsPos.y )
		local areaiy = iyslider:GetTextArea()
		areaiy.OnTextChanged = function() RunConsoleCommand("_sp_ironsight_y",areaiy:GetValue()) end
		
		addy = addy + 45
		
		local izslider = vgui.Create( "DNumSlider", pironsight )
		izslider:SetPos( 10, addy )
		izslider:SetWide( 260 )
		izslider:SetText( "Translate z" )
		izslider:SetMin( -20 )
		izslider:SetMax( 20 )
		izslider:SetDecimals( 3 )
		izslider:SetConVar( "_sp_ironsight_z" )
		izslider:SetValue( save_data.IronSightsPos.z )
		local areaiz = izslider:GetTextArea()
		areaiz.OnTextChanged = function() RunConsoleCommand("_sp_ironsight_z",areaiz:GetValue()) end
		
		addy = addy + 45
		
		local ipslider = vgui.Create( "DNumSlider", pironsight )
		ipslider:SetPos( 10, addy )
		ipslider:SetWide( 260 )
		ipslider:SetText( "Rotate pitch" )
		ipslider:SetMin( -70 )
		ipslider:SetMax( 70 )
		ipslider:SetDecimals( 3 )
		ipslider:SetConVar( "_sp_ironsight_pitch" )
		ipslider:SetValue( save_data.IronSightsAng.x )
		local areaip = ipslider:GetTextArea()
		areaip.OnTextChanged = function() RunConsoleCommand("_sp_ironsight_pitch",areaip:GetValue()) end
		
		addy = addy + 45
		
		local iyaslider = vgui.Create( "DNumSlider", pironsight )
		iyaslider:SetPos( 10, addy )
		iyaslider:SetWide( 260 )
		iyaslider:SetText( "Rotate yaw" )
		iyaslider:SetMin( -70 )
		iyaslider:SetMax( 70 )
		iyaslider:SetDecimals( 3 )
		iyaslider:SetConVar( "_sp_ironsight_yaw" )
		iyaslider:SetValue( save_data.IronSightsAng.y )
		local areaiya = iyaslider:GetTextArea()
		areaiya.OnTextChanged = function() RunConsoleCommand("_sp_ironsight_yaw",areaiya:GetValue()) end
		
		addy = addy + 45
		
		local irslider = vgui.Create( "DNumSlider", pironsight )
		irslider:SetPos( 10, addy )
		irslider:SetWide( 260 )
		irslider:SetText( "Rotate roll" )
		irslider:SetMin( -70 )
		irslider:SetMax( 70 )
		irslider:SetDecimals( 3 )
		irslider:SetConVar( "_sp_ironsight_roll" )
		irslider:SetValue( save_data.IronSightsAng.z )
		local areair = irslider:GetTextArea()
		areair.OnTextChanged = function() RunConsoleCommand("_sp_ironsight_roll",areair:GetValue()) end
		
		addy = addy + 45
		
		local prbtn = vgui.Create( "DButton", pironsight )
		prbtn:SetPos( 10, addy )
		prbtn:SetSize( 260, 30 )
		prbtn:SetText( "Print ironsights code to console" )
		prbtn.DoClick = function()
			local vec, ang = wep:GetIronSightCoordination()
			MsgN("*********************************************")
			MsgN(GetIronSightPrintText( vec, ang ))
			MsgN("*********************************************")
			LocalPlayer():ChatPrint("Code printed to console!")
		end
		
		addy = addy + 35
		
		local pcbtn = vgui.Create( "DButton", pironsight )
		pcbtn:SetPos( 10, addy )
		pcbtn:SetSize( 260, 30 )
		pcbtn:SetText( "Copy ironsights code to clipboard" )
		pcbtn.DoClick = function()
			local vec, ang = wep:GetIronSightCoordination()
			SetClipboardText(GetIronSightPrintText( vec, ang ))
			LocalPlayer():ChatPrint("Code copied to clipboard!")
		end
		
		/*********************
			Models page
		*********************/
		addy = 10
		
		local lastVisible = ""
		local mlist = vgui.Create( "DListView", pmodels)
		v_modelListing = mlist

		local mlabel = vgui.Create( "DLabel", pmodels )
		mlabel:SetPos( 10, addy )
		mlabel:SetSize( 130, 20 )
		mlabel:SetText( "New viewmodel element:" )
		
		local function CreateNote( text )
			local templabel = vgui.Create( "DLabel" )
			templabel:SetText( text )
			templabel:SetSize( 120, 20 )

			local notif = vgui.Create( "DNotify" , pmodels )
			notif:SetPos( 140, 10 )
			notif:SetSize( 120, 20 )
			notif:SetLife( 5 )
			notif:AddItem(templabel)
			
		end
		
		addy = addy + 25
		
		local mntext = vgui.Create("DTextEntry", pmodels )
		mntext:SetPos( 10, addy )
		mntext:SetSize( 120, 20 )
		mntext:SetMultiline(false)
		mntext:SetText( "some_unique_name" )
		
		local tpbox = vgui.Create( "DMultiChoice", pmodels )
		tpbox:SetPos( 130, addy )
		tpbox:SetSize( 85, 20 )
		tpbox:SetEditable( false )
		tpbox:SetText( "Model" )
		tpbox:AddChoice( "Model" )
		tpbox:AddChoice( "Sprite" )
		tpbox:AddChoice( "Quad" )
		local boxselected = "Model"
		tpbox.OnSelect = function( p, index, value )
			boxselected = value
		end
		
		local mnbtn = vgui.Create( "DButton", pmodels )
		mnbtn:SetPos( 220, addy )
		mnbtn:SetSize( 45, 20 )
		mnbtn:SetText( "Add" )

		addy = addy + 30
		
		mlist:SetPos( 10, addy )
		mlist:SetSize( 260, 100 )
		mlist:SetMultiSelect(false)
		mlist:SetDrawBackground(true)
		mlist:AddColumn("Name")
		mlist:AddColumn("Type")
		// cache the created panels
		mlist.OnRowSelected = function( panel, line )
			local name = mlist:GetLine(line):GetValue(1)
			
			local posx, posy = v_panelCache[name]:GetPos()

			if (v_panelCache[lastVisible]) then
				v_panelCache[lastVisible]:SetVisible(false)
			end
			v_panelCache[name]:SetVisible(true)
			
			lastVisible = name
		end
		
		addy = addy + 105
		
		local rmbtn = vgui.Create( "DButton", pmodels )
		rmbtn:SetPos( 10, addy )
		rmbtn:SetSize( 260, 25 )
		rmbtn:SetText( "Remove selected" )
		
		addy = addy + 30
		
		local function CreatePositionModifiers( data, addy, panel )
			
			local trlabel = vgui.Create( "DLabel", panel )
			trlabel:SetPos( 5, addy )
			trlabel:SetSize( 80, 20 )
			trlabel:SetText( "Pos x/y/z:" )
			
			local mxwang = vgui.Create( "DNumberWang", panel )
			mxwang:SetPos( 90, addy )
			mxwang:SetSize( 50, 20 )
			mxwang:SetMin( -30 )
			mxwang:SetMax( 30 )
			mxwang:SetDecimals( 3 )
			mxwang.OnValueChanged = function( p, value ) data.pos.x = tonumber(value) end
			mxwang:SetValue( data.pos.x )
			local areax = mxwang:GetTextArea()
			areax.OnTextChanged = function() mxwang:SetValue(tonumber(areax:GetValue())) end
			
			local mywang = vgui.Create( "DNumberWang", panel )
			mywang:SetPos( 145, addy )
			mywang:SetSize( 50, 20 )
			mywang:SetMin( -30 )
			mywang:SetMax( 30 )
			mywang:SetDecimals( 3 )
			mywang.OnValueChanged = function( p, value ) data.pos.y = tonumber(value) end
			mywang:SetValue( data.pos.y )
			local areay = mywang:GetTextArea()
			areay.OnTextChanged = function() mywang:SetValue(tonumber(areay:GetValue())) end
			
			local mzwang = vgui.Create( "DNumberWang", panel )
			mzwang:SetPos( 200, addy )
			mzwang:SetSize( 50, 20 )
			mzwang:SetMin( -30 )
			mzwang:SetMax( 30 )
			mzwang:SetDecimals( 3 )
			mzwang.OnValueChanged = function( p, value ) data.pos.z = tonumber(value) end
			mzwang:SetValue( data.pos.z )
			local areaz = mzwang:GetTextArea()
			areaz.OnTextChanged = function() mzwang:SetValue(tonumber(areaz:GetValue())) end
		
		end
		
		local function CreateAngleModifiers( data, addy, panel )
		
			local anlabel = vgui.Create( "DLabel", panel )
			anlabel:SetPos( 5, addy )
			anlabel:SetSize( 80, 20 )
			anlabel:SetText( "Angle p/y/r:" )
			
			local mpitchwang = vgui.Create( "DNumberWang", panel )
			mpitchwang:SetPos( 90, addy )
			mpitchwang:SetSize( 50, 20 )
			mpitchwang:SetMin( -180 )
			mpitchwang:SetMax( 180 )
			mpitchwang:SetDecimals( 3 )
			mpitchwang.OnValueChanged = function( p, value ) data.angle.p = tonumber(value) end
			mpitchwang:SetValue( data.angle.p )
			local areap = mpitchwang:GetTextArea()
			areap.OnTextChanged = function() mpitchwang:SetValue(tonumber(areap:GetValue())) end
			
			local myawwang = vgui.Create( "DNumberWang", panel )
			myawwang:SetPos( 145, addy )
			myawwang:SetSize( 50, 20 )
			myawwang:SetMin( -180 )
			myawwang:SetMax( 180 )
			myawwang:SetDecimals( 3 )
			myawwang.OnValueChanged = function( p, value ) data.angle.y = tonumber(value) end
			myawwang:SetValue( data.angle.y )
			local areay = myawwang:GetTextArea()
			areay.OnTextChanged = function() myawwang:SetValue(tonumber(areay:GetValue())) end
			
			local mrollwang = vgui.Create( "DNumberWang", panel )
			mrollwang:SetPos( 200, addy )
			mrollwang:SetSize( 50, 20 )
			mrollwang:SetMin( -180 )
			mrollwang:SetMax( 180 )
			mrollwang:SetDecimals( 3 )
			mrollwang.OnValueChanged = function( p, value ) data.angle.r = tonumber(value) end
			mrollwang:SetValue( data.angle.r )
			local arear = mrollwang:GetTextArea()
			arear.OnTextChanged = function() mrollwang:SetValue(tonumber(arear:GetValue())) end
			
		end
		
		local function CreateSizeModifiers( data, addy, panel, dimensions )

			local sizelabel = vgui.Create( "DLabel", panel )
			sizelabel:SetPos( 5, addy )
			sizelabel:SetSize( 80, 20 )
			
			if (dimensions == 2) then
				sizelabel:SetText( "Size (xy)/y:" )
			elseif ( dimensions == 3 ) then
				sizelabel:SetText( "Size (xyz)/y/z:" )
			else
				sizelabel:SetText( "Size:" )
			end
			
			local msxwang = vgui.Create( "DNumberWang", panel )
			msxwang:SetPos( 90, addy-2 )
			msxwang:SetSize( 52, 24 )
			msxwang:SetMin( 0.01 )
			msxwang:SetMax( 10 )
			msxwang:SetDecimals( 3 )
			local areasx = msxwang:GetTextArea()
			areasx.OnTextChanged = function() msxwang:SetValue(tonumber(areasx:GetValue())) end
			
			local msywang, mszwang

			if (dimensions > 1 ) then
			
				msywang = vgui.Create( "DNumberWang", panel )
				msywang:SetPos( 145, addy )
				msywang:SetSize( 50, 20 )
				msywang:SetMin( 0.01 )
				msywang:SetMax( 10 )
				msywang:SetDecimals( 3 )
				msywang.OnValueChanged = function( p, value ) data.size.y = tonumber(value) end
				local areasy = msywang:GetTextArea()
				areasy.OnTextChanged = function() msywang:SetValue(tonumber(areasy:GetValue())) end

				if (dimensions > 2) then
					mszwang = vgui.Create( "DNumberWang", panel )
					mszwang:SetPos( 200, addy )
					mszwang:SetSize( 50, 20 )
					mszwang:SetMin( 0.01 )
					mszwang:SetMax( 10 )
					mszwang:SetDecimals( 3 )
					mszwang.OnValueChanged = function( p, value ) data.size.z = tonumber(value) end
					local areasz = mszwang:GetTextArea()
					areasz.OnTextChanged = function() mszwang:SetValue(tonumber(areasz:GetValue())) end
				end
			
			end
			
			// make the x numberwang set the total size
			msxwang.OnValueChanged = function( p, value )
				if (mszwang) then
					mszwang:SetValue( value )
				end
				if (msywang) then
					msywang:SetValue( value )
				end
				
				if (dimensions > 1) then
					data.size.x = tonumber(value)
				else
					data.size = tonumber(value)
				end
			end
			
			if (dimensions == 1) then
				
				msxwang:SetValue( data.size )
				
			else
			
				local new_y = data.size.y
				local new_z = data.size.z
				
				msxwang:SetValue( data.size.x )
				msywang:SetValue( new_y )
				if (mszwang) then
					mszwang:SetValue( new_z )
				end
				
			end
			
		end
		
		local function CreateColorModifiers( data, addy, panel )
		
			local collabel = vgui.Create( "DLabel", panel )
			collabel:SetPos( 5, addy )
			collabel:SetSize( 80, 20 )
			collabel:SetText( "Color r/g/b/a:" )
			
			local colrwang = vgui.Create( "DNumberWang", panel )
			colrwang:SetPos( 90, addy )
			colrwang:SetSize( 38, 20 )
			colrwang:SetMin( 0 )
			colrwang:SetMax( 255 )
			colrwang:SetDecimals( 0 )
			colrwang.OnValueChanged = function( p, value ) data.color.r = tonumber(value) end
			colrwang:SetValue(data.color.r)
			local arear = colrwang:GetTextArea()
			arear.OnTextChanged = function() colrwang:SetValue(tonumber(arear:GetValue())) end
			
			local colgwang = vgui.Create( "DNumberWang", panel )
			colgwang:SetPos( 130, addy )
			colgwang:SetSize( 38, 20 )
			colgwang:SetMin( 0 )
			colgwang:SetMax( 255 )
			colgwang:SetDecimals( 0 )
			colgwang.OnValueChanged = function( p, value ) data.color.g = tonumber(value) end
			colgwang:SetValue(data.color.g)
			local areag = colgwang:GetTextArea()
			areag.OnTextChanged = function() colgwang:SetValue(tonumber(areag:GetValue())) end
			
			local colbwang = vgui.Create( "DNumberWang", panel )
			colbwang:SetPos( 170, addy )
			colbwang:SetSize( 38, 20 )
			colbwang:SetMin( 0 )
			colbwang:SetMax( 255 )
			colbwang:SetDecimals( 0 )
			colbwang.OnValueChanged = function( p, value ) data.color.b = tonumber(value) end
			colbwang:SetValue(data.color.b)
			local areab = colbwang:GetTextArea()
			areab.OnTextChanged = function() colbwang:SetValue(tonumber(areab:GetValue())) end
			
			local colawang = vgui.Create( "DNumberWang", panel )
			colawang:SetPos( 210, addy )
			colawang:SetSize( 40, 20 )
			colawang:SetMin( 0 )
			colawang:SetMax( 255 )
			colawang:SetDecimals( 0 )
			colawang.OnValueChanged = function( p, value ) data.color.a = tonumber(value) end
			colawang:SetValue(data.color.a)
			local areaa = colawang:GetTextArea()
			areaa.OnTextChanged = function() colawang:SetValue(tonumber(areaa:GetValue())) end
			
		end
		
		local function CreateModelModifier( data, addy, panel )
		
			local pmolabel = vgui.Create( "DLabel", panel )
			pmolabel:SetPos( 5, addy )
			pmolabel:SetSize( 80, 20 )
			pmolabel:SetText( "Model:" )
			
			local pmmtext = vgui.Create( "DTextEntry", panel )
			pmmtext:SetPos( 60, addy )
			pmmtext:SetSize( 170, 20 )
			pmmtext:SetMultiline(false)
			pmmtext.OnTextChanged = function()
				local newmod = pmmtext:GetValue()
				if file.Exists ("../"..newmod) then
					util.PrecacheModel(newmod)
					data.model = newmod
				end
			end
			pmmtext:SetText( data.model )
			pmmtext.OnTextChanged()
			
			local wtbtn = vgui.Create( "DButton", panel )
			wtbtn:SetPos( 230, addy )
			wtbtn:SetSize( 20, 20 )
			wtbtn:SetText("...")
			wtbtn.DoClick = function()
				OpenBrowser( data.model, "model", function( val ) pmmtext:SetText(val) pmmtext:OnTextChanged() end )
			end
			
		end
		
		local function CreateSpriteModifier( data, addy, panel )
		
			local pmolabel = vgui.Create( "DLabel", panel )
			pmolabel:SetPos( 5, addy )
			pmolabel:SetSize( 80, 20 )
			pmolabel:SetText( "Sprite:" )
			
			local pmmtext = vgui.Create( "DTextEntry", panel )
			pmmtext:SetPos( 60, addy )
			pmmtext:SetSize( 170, 20 )
			pmmtext:SetMultiline(false)
			pmmtext.OnTextChanged = function()
				local newsprite = pmmtext:GetValue()
				if file.Exists ("../materials/"..newsprite..".vmt") then
					data.sprite = newsprite
				end
			end
			pmmtext:SetText( data.sprite )
			pmmtext.OnTextChanged()
			
			local wtbtn = vgui.Create( "DButton", panel )
			wtbtn:SetPos( 230, addy )
			wtbtn:SetSize( 20, 20 )
			wtbtn:SetText("...")
			wtbtn.DoClick = function()
				OpenBrowser( data.sprite, "material", function( val ) pmmtext:SetText(val) pmmtext:OnTextChanged() end )
			end
			
			
		end
		
		local function CreateNameLabel( name, addy, panel )
			
			local pnmlabel = vgui.Create( "DLabel", panel )
			pnmlabel:SetPos( 5, addy )
			pnmlabel:SetSize( 80, 20 )
			pnmlabel:SetText( "Name:" )
			
			local pnmtext = vgui.Create( "DTextEntry", panel )
			pnmtext:SetPos( 60, addy )
			pnmtext:SetSize( 190, 20 )
			pnmtext:SetMultiline(false)
			pnmtext:SetText( name )
			pnmtext:SetEditable( false )
			
		end
		
		local function CreateParamModifiers( data, addy, panel )
		
			local ncchbox = vgui.Create( "DCheckBoxLabel", panel )
			ncchbox:SetPos( 5, addy )
			ncchbox:SetSize( 120, 20 )
			ncchbox:SetText("$nocull")
			ncchbox:SetValue( 0 )
			ncchbox.OnChange = function()
				data.nocull = ncchbox:GetChecked()
				data.spriteMaterial = nil // dump old material
			end
			if (data.nocull) then ncchbox:SetValue( 1 ) end
			
			local adchbox = vgui.Create( "DCheckBoxLabel", panel )
			adchbox:SetPos( 140, addy )
			adchbox:SetSize( 120, 20 )
			adchbox:SetText("$additive")
			adchbox:SetValue( 0 )
			adchbox.OnChange = function()
				data.additive = adchbox:GetChecked()
				data.spriteMaterial = nil // dump old material
			end
			if (data.additive) then adchbox:SetValue( 1 ) end
			
			addy = addy + 22
			
			local vtachbox = vgui.Create( "DCheckBoxLabel", panel )
			vtachbox:SetPos( 5, addy )
			vtachbox:SetSize( 120, 20 )
			vtachbox:SetText("$vertexalpha")
			vtachbox:SetValue( 0 )
			vtachbox.OnChange = function()
				data.vertexalpha = vtachbox:GetChecked()
				data.spriteMaterial = nil // dump old material
			end
			if (data.vertexalpha) then vtachbox:SetValue( 1 ) end
			
			local vtcchbox = vgui.Create( "DCheckBoxLabel", panel )
			vtcchbox:SetPos( 140, addy )
			vtcchbox:SetSize( 120, 20 )
			vtcchbox:SetText("$vertexcolor")
			vtcchbox:SetValue( 0 )
			vtcchbox.OnChange = function()
				data.vertexcolor = vtcchbox:GetChecked()
				data.spriteMaterial = nil // dump old material
			end
			if (data.vertexcolor) then vtcchbox:SetValue( 1 ) end
			
			addy = addy + 22
			
			local izchbox = vgui.Create( "DCheckBoxLabel", panel )
			izchbox:SetPos( 5, addy )
			izchbox:SetSize( 120, 20 )
			izchbox:SetText("$ignorez")
			izchbox:SetValue( 0 )
			izchbox.OnChange = function()
				data.ignorez = izchbox:GetChecked()
				data.spriteMaterial = nil // dump old material
			end
			if (data.ignorez) then izchbox:SetValue( 1 ) end
			
		end
		
		local function CreateMaterialModifier( data, addy, panel )
		
			local matlabel = vgui.Create( "DLabel", panel )
			matlabel:SetPos( 5, addy )
			matlabel:SetSize( 80, 20 )
			matlabel:SetText( "Material:" )

			local mattext = vgui.Create("DTextEntry", panel )
			mattext:SetPos( 90, addy )
			mattext:SetSize( 140, 20 )
			mattext:SetMultiline(false)
			mattext.OnTextChanged = function()
				local newmat = mattext:GetValue()
				if file.Exists ("../materials/"..newmat..".vmt") then
					data.material = newmat
				else
					data.material = ""
				end
			end
			mattext:SetText( data.material )
			
			local wtbtn = vgui.Create( "DButton", panel )
			wtbtn:SetPos( 230, addy )
			wtbtn:SetSize( 20, 20 )
			wtbtn:SetText("...")
			wtbtn.DoClick = function()
				OpenBrowser( data.material, "material", function( val ) mattext:SetText(val) mattext:OnTextChanged() end )
			end
			
		end
		
		local function CreateSLightningModifier( data, addy, panel )
		
			local lschbox = vgui.Create( "DCheckBoxLabel", panel )
			lschbox:SetPos( 5, addy )
			lschbox:SetSize( 200, 20 )
			lschbox:SetText("Surpress engine lightning")
			lschbox.OnChange = function()
				data.surpresslightning = lschbox:GetChecked()
			end
			if (data.surpresslightning) then
				lschbox:SetValue( 1 )
			else
				lschbox:SetValue( 0 )
			end
			
		end
		
		local function CreateBoneModifier( data, addy, panel )
			
			local pbonelabel = vgui.Create( "DLabel", panel )
			pbonelabel:SetPos( 5, addy )
			pbonelabel:SetSize( 80, 20 )
			pbonelabel:SetText( "Bone:" )
			
			local bonebox = vgui.Create( "DMultiChoice", panel )
			bonebox:SetPos( 60, addy )
			bonebox:SetSize( 190, 20 )
			bonebox:SetEditable( false )
			bonebox.OnSelect = function( p, index, value )
				data.bone = value
			end
			bonebox:SetText( data.bone )
			
			local delay = 0
			// we have to call it later when loading settings because the viewmodel needs to be changed first
			if (data.bone != "") then delay = 2 end
			
			timer.Simple(delay, function()
				local option = PopulateBoneList( bonebox )
				if (option and data.bone == "") then 
					bonebox:ChooseOptionID(1)
				end
			end)
			
		end
		
		local function CreateBodygroupSkinModifier( data, addy, panel )
		
			local addx = 5
		
			local bdlabel = vgui.Create( "DLabel", panel )
			bdlabel:SetPos( addx, addy )
			bdlabel:SetSize( 80, 20 )
			bdlabel:SetText( "Bodygroup:" )
			
			addx = addx + 85
			
			local bdwang = vgui.Create( "DNumberWang", panel )
			bdwang:SetPos( addx, addy )
			bdwang:SetSize( 30, 20 )
			bdwang:SetMin( 1 )
			bdwang:SetMax( 9 )
			bdwang:SetDecimals( 0 )
			local areabd = bdwang:GetTextArea()
			areabd.OnTextChanged = function() bdwang:SetValue(tonumber(areabd:GetValue())) end
			
			addx = addx + 30
			
			local islabel = vgui.Create( "DLabel", panel )
			islabel:SetPos( addx+2, addy )
			islabel:SetSize( 10, 20 )
			islabel:SetText( "=" )
			
			addx = addx + 10
			
			local bdvwang = vgui.Create( "DNumberWang", panel )
			bdvwang:SetPos( addx, addy )
			bdvwang:SetSize( 30, 20 )
			bdvwang:SetMin( 0 )
			bdvwang:SetMax( 9 )
			bdvwang:SetDecimals( 0 )
			local areabdv = bdvwang:GetTextArea()
			areabdv.OnTextChanged = function() bdvwang:SetValue(tonumber(areabdv:GetValue())) end
			
			bdvwang.OnValueChanged = function( p, value ) 
				local group = tonumber(bdwang:GetValue())
				local val = tonumber(value)
				data.bodygroup[group] = val
			end
			bdvwang:SetValue(0)

			bdwang.OnValueChanged = function( p, value )
				local group = tonumber(value)
				if (group < 1) then return end
				local setval = data.bodygroup[group] or 0
				bdvwang:SetValue(setval)
			end
			bdwang:SetValue(1)

			addx = addx + 50
			
			local sklabel = vgui.Create( "DLabel", panel )
			sklabel:SetPos( addx, addy )
			sklabel:SetSize( 40, 20 )
			sklabel:SetText( "Skin:" )
			
			addx = addx + 40
			
			local skwang = vgui.Create( "DNumberWang", panel )
			skwang:SetPos( addx, addy )
			skwang:SetSize( 30, 20 )
			skwang:SetMin( 0 )
			skwang:SetMax( 9 )
			skwang:SetDecimals( 0 )
			skwang.OnValueChanged = function( p, value ) data.skin = tonumber(value) end
			skwang:SetValue(data.skin)
			local areask = skwang:GetTextArea()
			areask.OnTextChanged = function() skwang:SetValue(tonumber(areask:GetValue())) end
			
		end
		
		
		local panely = addy
		
		/*** Model panel for adjusting models ***
		Name:
		Model:
		Bone name:
		Translation x / y / z
		Rotation pitch / yaw / role
		Model size x / y / z
		Material
		Color modulation
		*/
		local function CreateModelPanel( name, x, y, preset_data )
			
			local data = v_models[name]
			if (!preset_data) then preset_data = {} end
			
			// default data
			data.type = preset_data.type or "Model"
			data.model = preset_data.model or ""
			data.bone = preset_data.bone or ""
			data.pos = preset_data.pos or Vector(0,0,0)
			data.angle = preset_data.angle or Angle(0,0,0)
			data.size = preset_data.size or Vector(0.5,0.5,0.5)
			data.color = preset_data.color or Color(255,255,255,255)
			data.surpresslightning = preset_data.surpresslightning or false
			data.material = preset_data.material or ""
			data.bodygroup = preset_data.bodygroup or {}
			data.skin = preset_data.skin or 0
			
			vRenderOrder = nil // force viewmodel render order to recache
			
			local panel = vgui.Create( "DPanel", pmodels )
			panel:SetPos( x, y )
			panel:SetSize( 260, 514 - panely - 60 )
			panel:SetPaintBackground( true )
			panel.Paint = function() surface.SetDrawColor( 70, 70, 70, 255 ) surface.DrawRect( 0, 0, panel:GetWide(), panel:GetTall() ) end
			
			local addy = 5
			
			CreateNameLabel( name, addy, panel )
			
			addy = addy + 25
			
			CreateModelModifier( data, addy, panel )
			
			addy = addy + 25
			
			CreateBoneModifier( data, addy, panel )
			
			addy = addy + 25
			
			CreatePositionModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateAngleModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateSizeModifiers( data, addy, panel, 3 )
			
			addy = addy + 25
			
			CreateColorModifiers( data, addy, panel )
			
			addy = addy + 25
			
			CreateSLightningModifier( data, addy, panel )
			
			addy = addy + 22
			
			CreateMaterialModifier( data, addy, panel )
			
			addy = addy + 25
			
			CreateBodygroupSkinModifier( data, addy, panel )
			
			return panel
			
		end
		
		/*** Sprite panel for adjusting sprites ***
		Name:
		Sprite:
		Bone name:
		Translation x / y / z
		Sprite x / y size
		Color
		*/
		local function CreateSpritePanel( name, x, y, preset_data )
			
			local data = v_models[name]
			if (!preset_data) then preset_data = {} end
			
			// default data
			data.type = preset_data.type or "Sprite"
			data.sprite = preset_data.sprite or ""
			data.bone = preset_data.bone or ""
			data.pos = preset_data.pos or Vector(0,0,0)
			data.size = preset_data.size or { x = 1, y = 1 }
			data.color = preset_data.color or Color(255,255,255,255)
			data.nocull = preset_data.nocull or true
			data.additive = preset_data.additive or true
			data.vertexalpha = preset_data.vertexalpha or true
			data.vertexcolor = preset_data.vertexcolor or true
			data.ignorez = preset_data.ignorez or false
			
			vRenderOrder = nil
			
			local panel = vgui.Create( "DPanel", pmodels )
			panel:SetPos( x, y )
			panel:SetSize( 260, 514 - panely - 60 )
			panel:SetPaintBackground( true )
			panel.Paint = function() surface.SetDrawColor( 70, 70, 70, 255 ) surface.DrawRect( 0, 0, panel:GetWide(), panel:GetTall() ) end
			
			local addy = 5
			
			CreateNameLabel( name, addy, panel )
			
			addy = addy + 25
			
			CreateSpriteModifier( data, addy, panel )
			
			addy = addy + 25
			
			CreateBoneModifier( data, addy, panel )
			
			addy = addy + 25

			CreatePositionModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateSizeModifiers( data, addy, panel, 2 )

			addy = addy + 25
			
			CreateColorModifiers( data, addy, panel )
			
			addy = addy + 25
			
			CreateParamModifiers( data, addy, panel )
			
			return panel
			
		end
		
		/*** Model panel for adjusting models ***
		Name:
		Model:
		Bone name:
		Translation x / y / z
		Rotation pitch / yaw / role
		Size
		*/
		local function CreateQuadPanel( name, x, y, preset_data )
			
			local data = v_models[name]
			if (!preset_data) then preset_data = {} end
			
			// default data
			data.type = preset_data.type or "Quad"
			data.model = preset_data.model or ""
			data.bone = preset_data.bone or ""
			data.pos = preset_data.pos or Vector(0,0,0)
			data.angle = preset_data.angle or Angle(0,0,0)
			data.size = preset_data.size or 0.05

			vRenderOrder = nil // force viewmodel render order to recache
			
			local panel = vgui.Create( "DPanel", pmodels )
			panel:SetPos( x, y )
			panel:SetSize( 260, 514 - panely - 60 )
			panel:SetPaintBackground( true )
			panel.Paint = function() surface.SetDrawColor( 70, 70, 70, 255 ) surface.DrawRect( 0, 0, panel:GetWide(), panel:GetTall() ) end
			
			local addy = 5
			
			CreateNameLabel( name, addy, panel )
			
			addy = addy + 25
			
			CreateBoneModifier( data, addy, panel )
			
			addy = addy + 25
			
			CreatePositionModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateAngleModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateSizeModifiers( data, addy, panel, 1 )
			
			return panel
			
		end
		
		// adding button DoClick
		mnbtn.DoClick = function()
			local new = string.Trim( mntext:GetValue() )
			if (new) then
				if (new == "") then CreateNote("Empty name field!") return end
				if (v_models[new] != nil) then CreateNote("Name already exists!") return end
				v_models[new] = {}
				
				if (!v_panelCache[new]) then
					if (boxselected == "Model") then
						v_panelCache[new] = CreateModelPanel( new, 10, panely )
					elseif (boxselected == "Sprite") then
						v_panelCache[new] = CreateSpritePanel( new, 10, panely )
					elseif (boxselected == "Quad") then
						v_panelCache[new] = CreateQuadPanel( new, 10, panely )
					else
						Error("wtf are u doing")
					end
				end
				
				v_panelCache[new]:SetVisible(false)
				
				mlist:AddLine(new,boxselected)
			end
		end
		
		for k, v in pairs( save_data.v_models ) do
			v_models[k] = {}
			if (v.type == "Model") then
				v_panelCache[k] = CreateModelPanel( k, 10, panely, v )
			elseif (v.type == "Sprite") then
				v_panelCache[k] = CreateSpritePanel( k, 10, panely, v )
			elseif (v.type == "Quad") then
				v_panelCache[k] = CreateQuadPanel( k, 10, panely, v )
			end
			v_panelCache[k]:SetVisible(false)
			mlist:AddLine(k,v.type)
		
		end

		local prtbtn = vgui.Create( "DButton", pmodels)
		prtbtn:SetPos( 10, 465 )
		prtbtn:SetSize( 260, 20 )
		prtbtn:SetText("Print view model table to console")
		prtbtn.DoClick = function()
			MsgN("*********************************************")
			for k, v in pairs(string.Explode("\n",GetVModelsText())) do
				MsgN(v)
			end
			MsgN("*********************************************")
			LocalPlayer():ChatPrint("Code printed to console!")
		end
		
		local pctbtn = vgui.Create( "DButton", pmodels)
		pctbtn:SetPos( 10, 490 )
		pctbtn:SetSize( 260, 20 )
		pctbtn:SetText("Copy view model table to clipboard")
		pctbtn.DoClick = function()
			SetClipboardText(GetVModelsText())
			LocalPlayer():ChatPrint("Code copied to clipboard!")
		end
		
		// remove a line
		rmbtn.DoClick = function()
			local line = mlist:GetSelectedLine()
			if (line) then
				local name = mlist:GetLine(line):GetValue(1)
				v_models[name] = nil
				// clear from panel cache
				if (v_panelCache[name]) then 
					v_panelCache[name]:Remove()
					v_panelCache[name] = nil
				end
				mlist:RemoveLine(line)
			end
		end
		
		/*********************
			World models page
		*********************/
		addy = 10
		
		local lastVisible = ""
		local mwlist = vgui.Create( "DListView", pwmodels)
		w_modelListing = mwlist
		
		local mlabel = vgui.Create( "DLabel", pwmodels )
		mlabel:SetPos( 10, addy )
		mlabel:SetSize( 130, 20 )
		mlabel:SetText( "New worldmodel element:" )
		
		local function CreateWNote( text )
			local templabel = vgui.Create( "DLabel" )
			templabel:SetText( text )
			templabel:SetSize( 120, 20 )

			local notif = vgui.Create( "DNotify" , pwmodels )
			notif:SetPos( 140, 10 )
			notif:SetSize( 120, 20 )
			notif:SetLife( 5 )
			notif:AddItem(templabel)
		end
		
		addy = addy + 25
		
		local mnwtext = vgui.Create("DTextEntry", pwmodels )
		mnwtext:SetPos( 10, addy )
		mnwtext:SetSize( 120, 20 )
		mnwtext:SetMultiline(false)
		mnwtext:SetText( "some_unique_name" )
		
		local tpbox = vgui.Create( "DMultiChoice", pwmodels )
		tpbox:SetPos( 130, addy )
		tpbox:SetSize( 85, 20 )
		tpbox:SetEditable( false )
		tpbox:SetText( "Model" )
		tpbox:AddChoice( "Model" )
		tpbox:AddChoice( "Sprite" )
		tpbox:AddChoice( "Quad" )
		local wboxselected = "Model"
		tpbox.OnSelect = function( p, index, value )
			wboxselected = value
		end
		
		local mnwbtn = vgui.Create( "DButton", pwmodels )
		mnwbtn:SetPos( 220, addy )
		mnwbtn:SetSize( 45, 20 )
		mnwbtn:SetText( "Add" )
		
		addy = addy + 30
		
		mwlist:SetPos( 10, addy )
		mwlist:SetSize( 260, 105 )
		mwlist:SetMultiSelect(false)
		mwlist:SetDrawBackground(true)
		mwlist:AddColumn("Name")
		mwlist:AddColumn("Type")
		// cache the created panels
		mwlist.OnRowSelected = function( panel, line )
			local name = mwlist:GetLine(line):GetValue(1)
			
			if (w_panelCache[lastVisible]) then
				w_panelCache[lastVisible]:SetVisible(false)
			end
			w_panelCache[name]:SetVisible(true)
			
			lastVisible = name
		end
		
		addy = addy + 110
		
		local importbtn = vgui.Create( "DButton", pwmodels )
		importbtn:SetPos( 10, addy )
		importbtn:SetSize( 260, 20 )
		importbtn:SetText( "Import viewmodels" )
		
		addy = addy + 25
		
		local rmbtn = vgui.Create( "DButton", pwmodels )
		rmbtn:SetPos( 10, addy )
		rmbtn:SetSize( 260, 25 )
		rmbtn:SetText( "Remove selected" )
		
		addy = addy + 30
		
		local panely = addy
		
		/*** Model panel for adjusting models ***
		Name:
		Model:
		Translation x / y / z
		Rotation pitch / yaw / role
		Model size x / y / z
		Material
		Color modulation
		*/
		local function CreateWorldModelPanel( name, x, y, preset_data )
			
			local data = w_models[name]
			if (!preset_data) then preset_data = {} end
			
			// default data
			data.type = preset_data.type or "Model"
			data.model = preset_data.model or ""
			data.pos = preset_data.pos or Vector(0,0,0)
			data.angle = preset_data.angle or Angle(0,0,0)
			data.size = preset_data.size or Vector(0.5,0.5,0.5)
			data.color = preset_data.color or Color(255,255,255,255)
			data.surpresslightning = preset_data.surpresslightning or false
			data.material = preset_data.material or ""
			data.bodygroup = preset_data.bodygroup or {}
			data.skin = preset_data.skin or 0
			
			wRenderOrder = nil
			
			local panel = vgui.Create( "DPanel", pwmodels )
			panel:SetPos( x, y )
			panel:SetSize( 260, 514 - panely - 60 )
			panel:SetPaintBackground( true )
			panel.Paint = function() surface.SetDrawColor( 70, 70, 70, 255 ) surface.DrawRect( 0, 0, panel:GetWide(), panel:GetTall() ) end
			
			local addy = 5
			
			CreateNameLabel( name, addy, panel )
			
			addy = addy + 25
			
			CreateModelModifier( data, addy, panel )
			
			addy = addy + 25

			CreatePositionModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateAngleModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateSizeModifiers( data, addy, panel, 3 )
			
			addy = addy + 25
			
			CreateColorModifiers( data, addy, panel )
			
			addy = addy + 25
			
			CreateSLightningModifier( data, addy, panel )
			
			addy = addy + 22
			
			CreateMaterialModifier( data, addy, panel )
			
			addy = addy + 25
			
			CreateBodygroupSkinModifier( data, addy, panel )
			
			return panel
			
		end
		
		/*** Sprite panel for adjusting sprites ***
		Name:
		Sprite:
		Translation x / y / z
		Sprite x / y size
		Color
		*/
		local function CreateWorldSpritePanel( name, x, y, preset_data )
			
			local data = w_models[name]
			if (!preset_data) then preset_data = {} end
			
			// default data
			data.type = preset_data.type or "Sprite"
			data.sprite = preset_data.sprite or ""
			data.bone = preset_data.bone or ""
			data.pos = preset_data.pos or Vector(0,0,0)
			data.size = preset_data.size or { x = 1, y = 1 }
			data.color = preset_data.color or Color(255,255,255,255)
			data.nocull = preset_data.nocull or true
			data.additive = preset_data.additive or true
			data.vertexalpha = preset_data.vertexalpha or true
			data.vertexcolor = preset_data.vertexcolor or true
			data.ignorez = preset_data.ignorez or false
			
			wRenderOrder = nil
			
			local panel = vgui.Create( "DPanel", pwmodels )
			panel:SetPos( x, y )
			panel:SetSize( 260, 514 - panely - 60 )
			panel:SetPaintBackground( true )
			panel.Paint = function() surface.SetDrawColor( 70, 70, 70, 255 ) surface.DrawRect( 0, 0, panel:GetWide(), panel:GetTall() ) end
			
			local addy = 5
			
			CreateNameLabel( name, addy, panel )
			
			addy = addy + 25
			
			CreateSpriteModifier( data, addy, panel )
			
			addy = addy + 25

			CreatePositionModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateSizeModifiers( data, addy, panel, 2 )

			addy = addy + 25
			
			CreateColorModifiers( data, addy, panel )
			
			addy = addy + 25
			
			CreateParamModifiers( data, addy, panel )
			
			return panel
			
		end
		
		/*** Model panel for adjusting models ***
		Name:
		Model:
		Bone name:
		Translation x / y / z
		Rotation pitch / yaw / role
		Size
		*/
		local function CreateWorldQuadPanel( name, x, y, preset_data )
			
			local data = w_models[name]
			if (!preset_data) then preset_data = {} end
			
			// default data
			data.type = preset_data.type or "Quad"
			data.model = preset_data.model or ""
			data.bone = preset_data.bone or ""
			data.pos = preset_data.pos or Vector(0,0,0)
			data.angle = preset_data.angle or Angle(0,0,0)
			data.size = preset_data.size or 0.05

			vRenderOrder = nil // force viewmodel render order to recache
			
			local panel = vgui.Create( "DPanel", pwmodels )
			panel:SetPos( x, y )
			panel:SetSize( 260, 514 - panely - 60 )
			panel:SetPaintBackground( true )
			panel.Paint = function() surface.SetDrawColor( 70, 70, 70, 255 ) surface.DrawRect( 0, 0, panel:GetWide(), panel:GetTall() ) end
			
			local addy = 5
			
			CreateNameLabel( name, addy, panel )
			
			addy = addy + 25
			
			CreatePositionModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateAngleModifiers( data, addy, panel )
			
			addy = addy + 25

			CreateSizeModifiers( data, addy, panel, 1 )
			
			return panel
			
		end
		
		// adding button DoClick
		mnwbtn.DoClick = function()
			local new = string.Trim( mnwtext:GetValue() )
			if (new) then
				if (new == "") then CreateWNote("Empty name field!") return end
				if (w_models[new] != nil) then CreateWNote("Name already exists!") return end
				w_models[new] = {}
				
				if (!w_panelCache[new]) then
					if (wboxselected == "Model") then
						w_panelCache[new] = CreateWorldModelPanel( new, 10, panely )
					elseif (wboxselected == "Sprite") then
						w_panelCache[new] = CreateWorldSpritePanel( new, 10, panely )
					elseif (wboxselected == "Quad") then
						w_panelCache[new] = CreateWorldQuadPanel( new, 10, panely )
					else
						Error("wtf are u doing")
					end
				end
				
				w_panelCache[new]:SetVisible(false)
				
				mwlist:AddLine(new,wboxselected)
			end
		end
		
		for k, v in pairs( save_data.w_models ) do
			w_models[k] = {}
			if (v.type == "Model") then
				w_panelCache[k] = CreateWorldModelPanel( k, 10, panely, v )
			elseif (v.type == "Sprite") then
				w_panelCache[k] = CreateWorldSpritePanel( k, 10, panely, v )
			elseif (v.type == "Quad") then
				w_panelCache[k] = CreateWorldQuadPanel( k, 10, panely, v )
			end			
			w_panelCache[k]:SetVisible(false)
			mwlist:AddLine(k,v.type)
		
		end
		
		local prtbtn = vgui.Create( "DButton", pwmodels)
		prtbtn:SetPos( 10, 465 )
		prtbtn:SetSize( 260, 20 )
		prtbtn:SetText("Print world model table to console")
		prtbtn.DoClick = function()
			MsgN("*********************************************")
			for k, v in pairs(string.Explode("\n",GetWModelsText())) do
				MsgN(v)
			end
			MsgN("*********************************************")
			LocalPlayer():ChatPrint("Code printed to console!")
		end
		
		local pctbtn = vgui.Create( "DButton", pwmodels)
		pctbtn:SetPos( 10, 490 )
		pctbtn:SetSize( 260, 20 )
		pctbtn:SetText("Copy world model table to clipboard")
		pctbtn.DoClick = function()
			SetClipboardText(GetWModelsText())
			LocalPlayer():ChatPrint("Code copied to clipboard!")
		end
		
		// import viewmodels
		importbtn.DoClick = function()
			local num = 0
			for k, v in pairs( v_models ) do
				local name = k
				local i = 1
				while(w_models[name] != nil) do
					name = k..""..i
					i = i + 1
				end
				
				local new_preset = table.Copy(v)
				new_preset.bone = nil // don't need no bones
				new_preset.angle = Angle(0,0,0)
				new_preset.pos = Vector(num*5,0,-10)
				if (v.color) then
					new_preset.color = Color(v.color.r,v.color.g,v.color.b,v.color.a)
				end
				if (type(v.size) == "table") then
					new_preset.size = table.Copy(v.size)
				elseif (type(v.size) == "Vector") then
					new_preset.size = Vector(v.size.x, v.size.y, v.size.z)
				end
				if (v.bodygroup) then
					new_preset.bodygroup = table.Copy(v.bodygroup)
				end
				
				w_models[name] = {}
				if (v.type == "Model") then
					w_panelCache[name] = CreateWorldModelPanel( name, 10, panely, new_preset )
				elseif (v.type == "Sprite") then
					w_panelCache[name] = CreateWorldSpritePanel( name, 10, panely, new_preset )
				elseif (v.type == "Quad") then
					w_panelCache[name] = CreateWorldQuadPanel( name, 10, panely, new_preset )
				end				
				w_panelCache[name]:SetVisible(false)
				mwlist:AddLine(name,v.type)
				
				num = num + 1
			end
		end
		
		// remove a line
		rmbtn.DoClick = function()
			local line = mwlist:GetSelectedLine()
			if (line) then
				local name = mwlist:GetLine(line):GetValue(1)
				w_models[name] = nil
				// clear from panel cache
				if (w_panelCache[name]) then 
					w_panelCache[name]:Remove()
					w_panelCache[name] = nil
				end
				mwlist:RemoveLine(line)
			end
		end

		return f

	end

	function SWEP:OpenMenu( preset )
		if (!self.Frame) then
			self.Frame = CreateMenu( preset )
		end
		
		if (ValidEntity(self.Frame)) then
			self.Frame:SetVisible(true)
			self.Frame:MakePopup()
		else
			self.Frame = nil
		end
		
	end
	
	function SWEP:OnRemove()
		self:CleanMenu()
	end
	
	function SWEP:OnDropWeapon()
		self.LastOwner = nil
		if (!self.Frame) then return end
		self.Frame:Close()
	end

	function SWEP:CleanMenu()
		self:RemoveModels()
		if (!self.Frame) then return end
		v_modelListing = nil
		w_modelListing = nil
		v_panelCache = {}
		w_panelCache = {}
		self.Frame:Remove()
		self.Frame = nil
	end
	
	function SWEP:HUDShouldDraw( el )
		return el != "CHudAmmo" and el != "CHudSecondaryAmmo"
	end
	
	/***************************
		Third person view
	***************************/
	function ThirdPersonCalcView(pl, pos, angles, fov)
	
		local wep = pl:GetActiveWeapon()
		if (!useThirdPerson or !ValidEntity(wep) or !wep.IsSCK) then
			useThirdPerson = false
			return 
		end
		
		local look_pos = pos
		local rhand_bone = pl:LookupBone("ValveBiped.Bip01_R_Hand")
		if (rhand_bone) then
			look_pos = pl:GetBonePosition( rhand_bone )
		end
		
		local view = {}
		view.origin = look_pos + ((pl:GetAngles()+thirdPersonAngle):Forward()*thirdPersonDis)
		view.angles = (look_pos - view.origin):Angle()
		view.fov = fov
	 
		return view
	end
	 
	hook.Add("CalcView", "ThirdPersonCalcView", ThirdPersonCalcView)
	 
	hook.Add("ShouldDrawLocalPlayer", "ThirdPerson", function(pl)
			return useThirdPerson
	end)

end